package fsd.diagram.edit.commands;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.command.CommandResult;
import org.eclipse.gmf.runtime.emf.type.core.commands.EditElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientReferenceRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientRelationshipRequest;

import fsd.FailureComponentEnd;
import fsd.FailureComponentHead;
import fsd.diagram.edit.policies.FsdBaseItemSemanticEditPolicy;

/**
 * @generated
 */
public class FailureComponentHeadFailureTailReorientCommand extends
		EditElementCommand {

	/**
	 * @generated
	 */
	private final int reorientDirection;

	/**
	 * @generated
	 */
	private final EObject referenceOwner;

	/**
	 * @generated
	 */
	private final EObject oldEnd;

	/**
	 * @generated
	 */
	private final EObject newEnd;

	/**
	 * @generated
	 */
	public FailureComponentHeadFailureTailReorientCommand(
			ReorientReferenceRelationshipRequest request) {
		super(request.getLabel(), null, request);
		reorientDirection = request.getDirection();
		referenceOwner = request.getReferenceOwner();
		oldEnd = request.getOldRelationshipEnd();
		newEnd = request.getNewRelationshipEnd();
	}

	/**
	 * @generated
	 */
	public boolean canExecute() {
		if (false == referenceOwner instanceof FailureComponentHead) {
			return false;
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return canReorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return canReorientTarget();
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean canReorientSource() {
		if (!(oldEnd instanceof FailureComponentEnd && newEnd instanceof FailureComponentHead)) {
			return false;
		}
		return FsdBaseItemSemanticEditPolicy.getLinkConstraints()
				.canExistFailureComponentHeadFailureTail_4002(getNewSource(),
						getOldTarget());
	}

	/**
	 * @generated
	 */
	protected boolean canReorientTarget() {
		if (!(oldEnd instanceof FailureComponentEnd && newEnd instanceof FailureComponentEnd)) {
			return false;
		}
		return FsdBaseItemSemanticEditPolicy.getLinkConstraints()
				.canExistFailureComponentHeadFailureTail_4002(getOldSource(),
						getNewTarget());
	}

	/**
	 * @generated
	 */
	protected CommandResult doExecuteWithResult(IProgressMonitor monitor,
			IAdaptable info) throws ExecutionException {
		if (!canExecute()) {
			throw new ExecutionException(
					"Invalid arguments in reorient link command"); //$NON-NLS-1$
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return reorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return reorientTarget();
		}
		throw new IllegalStateException();
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientSource() throws ExecutionException {
		getOldSource().getFailureTail().remove(getOldTarget());
		getNewSource().getFailureTail().add(getOldTarget());
		return CommandResult.newOKCommandResult(referenceOwner);
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientTarget() throws ExecutionException {
		getOldSource().getFailureTail().remove(getOldTarget());
		getOldSource().getFailureTail().add(getNewTarget());
		return CommandResult.newOKCommandResult(referenceOwner);
	}

	/**
	 * @generated
	 */
	protected FailureComponentHead getOldSource() {
		return (FailureComponentHead) referenceOwner;
	}

	/**
	 * @generated
	 */
	protected FailureComponentHead getNewSource() {
		return (FailureComponentHead) newEnd;
	}

	/**
	 * @generated
	 */
	protected FailureComponentEnd getOldTarget() {
		return (FailureComponentEnd) oldEnd;
	}

	/**
	 * @generated
	 */
	protected FailureComponentEnd getNewTarget() {
		return (FailureComponentEnd) newEnd;
	}
}
