package fsd.diagram.edit.commands;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.command.CommandResult;
import org.eclipse.gmf.runtime.emf.type.core.commands.EditElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientReferenceRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientRelationshipRequest;

import fsd.PartComponent;
import fsd.PartComponentFailure;
import fsd.diagram.edit.policies.FsdBaseItemSemanticEditPolicy;

/**
 * @generated
 */
public class PartComponentFailureFailRegmessageReorientCommand extends
		EditElementCommand {

	/**
	 * @generated
	 */
	private final int reorientDirection;

	/**
	 * @generated
	 */
	private final EObject referenceOwner;

	/**
	 * @generated
	 */
	private final EObject oldEnd;

	/**
	 * @generated
	 */
	private final EObject newEnd;

	/**
	 * @generated
	 */
	public PartComponentFailureFailRegmessageReorientCommand(
			ReorientReferenceRelationshipRequest request) {
		super(request.getLabel(), null, request);
		reorientDirection = request.getDirection();
		referenceOwner = request.getReferenceOwner();
		oldEnd = request.getOldRelationshipEnd();
		newEnd = request.getNewRelationshipEnd();
	}

	/**
	 * @generated
	 */
	public boolean canExecute() {
		if (false == referenceOwner instanceof PartComponentFailure) {
			return false;
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return canReorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return canReorientTarget();
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean canReorientSource() {
		if (!(oldEnd instanceof PartComponent && newEnd instanceof PartComponentFailure)) {
			return false;
		}
		return FsdBaseItemSemanticEditPolicy.getLinkConstraints()
				.canExistPartComponentFailureFailRegmessage_4003(
						getNewSource(), getOldTarget());
	}

	/**
	 * @generated
	 */
	protected boolean canReorientTarget() {
		if (!(oldEnd instanceof PartComponent && newEnd instanceof PartComponent)) {
			return false;
		}
		return FsdBaseItemSemanticEditPolicy.getLinkConstraints()
				.canExistPartComponentFailureFailRegmessage_4003(
						getOldSource(), getNewTarget());
	}

	/**
	 * @generated
	 */
	protected CommandResult doExecuteWithResult(IProgressMonitor monitor,
			IAdaptable info) throws ExecutionException {
		if (!canExecute()) {
			throw new ExecutionException(
					"Invalid arguments in reorient link command"); //$NON-NLS-1$
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return reorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return reorientTarget();
		}
		throw new IllegalStateException();
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientSource() throws ExecutionException {
		getOldSource().getFailRegmessage().remove(getOldTarget());
		getNewSource().getFailRegmessage().add(getOldTarget());
		return CommandResult.newOKCommandResult(referenceOwner);
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientTarget() throws ExecutionException {
		getOldSource().getFailRegmessage().remove(getOldTarget());
		getOldSource().getFailRegmessage().add(getNewTarget());
		return CommandResult.newOKCommandResult(referenceOwner);
	}

	/**
	 * @generated
	 */
	protected PartComponentFailure getOldSource() {
		return (PartComponentFailure) referenceOwner;
	}

	/**
	 * @generated
	 */
	protected PartComponentFailure getNewSource() {
		return (PartComponentFailure) newEnd;
	}

	/**
	 * @generated
	 */
	protected PartComponent getOldTarget() {
		return (PartComponent) oldEnd;
	}

	/**
	 * @generated
	 */
	protected PartComponent getNewTarget() {
		return (PartComponent) newEnd;
	}
}
