package fsd.diagram.edit.parts;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;
import org.eclipse.gef.tools.CellEditorLocator;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ITextAwareEditPart;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.gmf.tooling.runtime.directedit.locator.CellEditorLocatorAccess;

import fsd.diagram.part.FsdVisualIDRegistry;

/**
 * @generated
 */
public class FsdEditPartFactory implements EditPartFactory {

	/**
	 * @generated
	 */
	public EditPart createEditPart(EditPart context, Object model) {
		if (model instanceof View) {
			View view = (View) model;
			switch (FsdVisualIDRegistry.getVisualID(view)) {

			case InteractionEditPart.VISUAL_ID:
				return new InteractionEditPart(view);

			case FailureComponentHeadEditPart.VISUAL_ID:
				return new FailureComponentHeadEditPart(view);

			case FailureComponentHeadTitleEditPart.VISUAL_ID:
				return new FailureComponentHeadTitleEditPart(view);

			case ComponentHeadEditPart.VISUAL_ID:
				return new ComponentHeadEditPart(view);

			case ComponentHeadTitleEditPart.VISUAL_ID:
				return new ComponentHeadTitleEditPart(view);

			case FailureNoteEditPart.VISUAL_ID:
				return new FailureNoteEditPart(view);

			case FailureNoteTextEditPart.VISUAL_ID:
				return new FailureNoteTextEditPart(view);

			case ComponentEndEditPart.VISUAL_ID:
				return new ComponentEndEditPart(view);

			case ComponentEndEndEditPart.VISUAL_ID:
				return new ComponentEndEndEditPart(view);

			case PartComponentEditPart.VISUAL_ID:
				return new PartComponentEditPart(view);

			case PartComponentFailureEditPart.VISUAL_ID:
				return new PartComponentFailureEditPart(view);

			case MitigationNoteEditPart.VISUAL_ID:
				return new MitigationNoteEditPart(view);

			case MitigationNoteTextEditPart.VISUAL_ID:
				return new MitigationNoteTextEditPart(view);

			case MessageCommentEditPart.VISUAL_ID:
				return new MessageCommentEditPart(view);

			case MessageCommentMessageEditPart.VISUAL_ID:
				return new MessageCommentMessageEditPart(view);

			case FailureIndicatorEditPart.VISUAL_ID:
				return new FailureIndicatorEditPart(view);

			case MitigationIndicatorEditPart.VISUAL_ID:
				return new MitigationIndicatorEditPart(view);

			case FailureComponentEndEditPart.VISUAL_ID:
				return new FailureComponentEndEditPart(view);

			case FailureComponentEndEndEditPart.VISUAL_ID:
				return new FailureComponentEndEndEditPart(view);

			case PartComponentRegFailMessageEditPart.VISUAL_ID:
				return new PartComponentRegFailMessageEditPart(view);

			case PartComponentFailureFailureFailureMessageEditPart.VISUAL_ID:
				return new PartComponentFailureFailureFailureMessageEditPart(
						view);

			case PartComponentFailureFailRegmessageEditPart.VISUAL_ID:
				return new PartComponentFailureFailRegmessageEditPart(view);

			case PartComponentRegularregularMessageEditPart.VISUAL_ID:
				return new PartComponentRegularregularMessageEditPart(view);

			case ComponentHeadNormalTailEditPart.VISUAL_ID:
				return new ComponentHeadNormalTailEditPart(view);

			case FailureComponentHeadFailureTailEditPart.VISUAL_ID:
				return new FailureComponentHeadFailureTailEditPart(view);

			}
		}
		return createUnrecognizedEditPart(context, model);
	}

	/**
	 * @generated
	 */
	private EditPart createUnrecognizedEditPart(EditPart context, Object model) {
		// Handle creation of unrecognized child node EditParts here
		return null;
	}

	/**
	 * @generated
	 */
	public static CellEditorLocator getTextCellEditorLocator(
			ITextAwareEditPart source) {
		return CellEditorLocatorAccess.INSTANCE
				.getTextCellEditorLocator(source);
	}

}
