package fsd.diagram.edit.policies;

import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.gef.commands.Command;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.emf.commands.core.commands.DuplicateEObjectsCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DuplicateElementsRequest;

import fsd.diagram.edit.commands.ComponentEndCreateCommand;
import fsd.diagram.edit.commands.ComponentHeadCreateCommand;
import fsd.diagram.edit.commands.FailureComponentEndCreateCommand;
import fsd.diagram.edit.commands.FailureComponentHeadCreateCommand;
import fsd.diagram.edit.commands.FailureIndicatorCreateCommand;
import fsd.diagram.edit.commands.FailureNoteCreateCommand;
import fsd.diagram.edit.commands.MessageCommentCreateCommand;
import fsd.diagram.edit.commands.MitigationIndicatorCreateCommand;
import fsd.diagram.edit.commands.MitigationNoteCreateCommand;
import fsd.diagram.edit.commands.PartComponentCreateCommand;
import fsd.diagram.edit.commands.PartComponentFailureCreateCommand;
import fsd.diagram.providers.FsdElementTypes;

/**
 * @generated
 */
public class InteractionItemSemanticEditPolicy extends
		FsdBaseItemSemanticEditPolicy {

	/**
	 * @generated
	 */
	public InteractionItemSemanticEditPolicy() {
		super(FsdElementTypes.Interaction_1000);
	}

	/**
	 * @generated
	 */
	protected Command getCreateCommand(CreateElementRequest req) {
		if (FsdElementTypes.FailureComponentHead_2011 == req.getElementType()) {
			return getGEFWrapper(new FailureComponentHeadCreateCommand(req));
		}
		if (FsdElementTypes.ComponentHead_2007 == req.getElementType()) {
			return getGEFWrapper(new ComponentHeadCreateCommand(req));
		}
		if (FsdElementTypes.FailureNote_2002 == req.getElementType()) {
			return getGEFWrapper(new FailureNoteCreateCommand(req));
		}
		if (FsdElementTypes.ComponentEnd_2006 == req.getElementType()) {
			return getGEFWrapper(new ComponentEndCreateCommand(req));
		}
		if (FsdElementTypes.PartComponent_2003 == req.getElementType()) {
			return getGEFWrapper(new PartComponentCreateCommand(req));
		}
		if (FsdElementTypes.PartComponentFailure_2005 == req.getElementType()) {
			return getGEFWrapper(new PartComponentFailureCreateCommand(req));
		}
		if (FsdElementTypes.MitigationNote_2009 == req.getElementType()) {
			return getGEFWrapper(new MitigationNoteCreateCommand(req));
		}
		if (FsdElementTypes.MessageComment_2008 == req.getElementType()) {
			return getGEFWrapper(new MessageCommentCreateCommand(req));
		}
		if (FsdElementTypes.FailureIndicator_2001 == req.getElementType()) {
			return getGEFWrapper(new FailureIndicatorCreateCommand(req));
		}
		if (FsdElementTypes.MitigationIndicator_2004 == req.getElementType()) {
			return getGEFWrapper(new MitigationIndicatorCreateCommand(req));
		}
		if (FsdElementTypes.FailureComponentEnd_2010 == req.getElementType()) {
			return getGEFWrapper(new FailureComponentEndCreateCommand(req));
		}
		return super.getCreateCommand(req);
	}

	/**
	 * @generated
	 */
	protected Command getDuplicateCommand(DuplicateElementsRequest req) {
		TransactionalEditingDomain editingDomain = ((IGraphicalEditPart) getHost())
				.getEditingDomain();
		return getGEFWrapper(new DuplicateAnythingCommand(editingDomain, req));
	}

	/**
	 * @generated
	 */
	private static class DuplicateAnythingCommand extends
			DuplicateEObjectsCommand {

		/**
		 * @generated
		 */
		public DuplicateAnythingCommand(
				TransactionalEditingDomain editingDomain,
				DuplicateElementsRequest req) {
			super(editingDomain, req.getLabel(), req
					.getElementsToBeDuplicated(), req
					.getAllDuplicatedElementsMap());
		}

	}

}
