package fsd.diagram.navigator;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.LinkedList;

import org.eclipse.core.resources.IFile;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.edit.domain.AdapterFactoryEditingDomain;
import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.emf.workspace.util.WorkspaceSynchronizer;
import org.eclipse.gmf.runtime.emf.core.GMFEditingDomainFactory;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.Edge;
import org.eclipse.gmf.runtime.notation.Node;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.navigator.ICommonContentExtensionSite;
import org.eclipse.ui.navigator.ICommonContentProvider;

import fsd.diagram.edit.parts.ComponentEndEditPart;
import fsd.diagram.edit.parts.ComponentHeadEditPart;
import fsd.diagram.edit.parts.ComponentHeadNormalTailEditPart;
import fsd.diagram.edit.parts.FailureComponentEndEditPart;
import fsd.diagram.edit.parts.FailureComponentHeadEditPart;
import fsd.diagram.edit.parts.FailureComponentHeadFailureTailEditPart;
import fsd.diagram.edit.parts.FailureIndicatorEditPart;
import fsd.diagram.edit.parts.FailureNoteEditPart;
import fsd.diagram.edit.parts.InteractionEditPart;
import fsd.diagram.edit.parts.MessageCommentEditPart;
import fsd.diagram.edit.parts.MitigationIndicatorEditPart;
import fsd.diagram.edit.parts.MitigationNoteEditPart;
import fsd.diagram.edit.parts.PartComponentEditPart;
import fsd.diagram.edit.parts.PartComponentFailureEditPart;
import fsd.diagram.edit.parts.PartComponentFailureFailRegmessageEditPart;
import fsd.diagram.edit.parts.PartComponentFailureFailureFailureMessageEditPart;
import fsd.diagram.edit.parts.PartComponentRegFailMessageEditPart;
import fsd.diagram.edit.parts.PartComponentRegularregularMessageEditPart;
import fsd.diagram.part.FsdVisualIDRegistry;
import fsd.diagram.part.Messages;

/**
 * @generated
 */
public class FsdNavigatorContentProvider implements ICommonContentProvider {

	/**
	 * @generated
	 */
	private static final Object[] EMPTY_ARRAY = new Object[0];

	/**
	 * @generated
	 */
	private Viewer myViewer;

	/**
	 * @generated
	 */
	private AdapterFactoryEditingDomain myEditingDomain;

	/**
	 * @generated
	 */
	private WorkspaceSynchronizer myWorkspaceSynchronizer;

	/**
	 * @generated
	 */
	private Runnable myViewerRefreshRunnable;

	/**
	 * @generated
	 */
	@SuppressWarnings({ "unchecked", "serial", "rawtypes" })
	public FsdNavigatorContentProvider() {
		TransactionalEditingDomain editingDomain = GMFEditingDomainFactory.INSTANCE
				.createEditingDomain();
		myEditingDomain = (AdapterFactoryEditingDomain) editingDomain;
		myEditingDomain.setResourceToReadOnlyMap(new HashMap() {
			public Object get(Object key) {
				if (!containsKey(key)) {
					put(key, Boolean.TRUE);
				}
				return super.get(key);
			}
		});
		myViewerRefreshRunnable = new Runnable() {
			public void run() {
				if (myViewer != null) {
					myViewer.refresh();
				}
			}
		};
		myWorkspaceSynchronizer = new WorkspaceSynchronizer(editingDomain,
				new WorkspaceSynchronizer.Delegate() {
					public void dispose() {
					}

					public boolean handleResourceChanged(final Resource resource) {
						unloadAllResources();
						asyncRefresh();
						return true;
					}

					public boolean handleResourceDeleted(Resource resource) {
						unloadAllResources();
						asyncRefresh();
						return true;
					}

					public boolean handleResourceMoved(Resource resource,
							final URI newURI) {
						unloadAllResources();
						asyncRefresh();
						return true;
					}
				});
	}

	/**
	 * @generated
	 */
	public void dispose() {
		myWorkspaceSynchronizer.dispose();
		myWorkspaceSynchronizer = null;
		myViewerRefreshRunnable = null;
		myViewer = null;
		unloadAllResources();
		((TransactionalEditingDomain) myEditingDomain).dispose();
		myEditingDomain = null;
	}

	/**
	 * @generated
	 */
	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
		myViewer = viewer;
	}

	/**
	 * @generated
	 */
	void unloadAllResources() {
		for (Resource nextResource : myEditingDomain.getResourceSet()
				.getResources()) {
			nextResource.unload();
		}
	}

	/**
	 * @generated
	 */
	void asyncRefresh() {
		if (myViewer != null && !myViewer.getControl().isDisposed()) {
			myViewer.getControl().getDisplay()
					.asyncExec(myViewerRefreshRunnable);
		}
	}

	/**
	 * @generated
	 */
	public Object[] getElements(Object inputElement) {
		return getChildren(inputElement);
	}

	/**
	 * @generated
	 */
	public void restoreState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void saveState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void init(ICommonContentExtensionSite aConfig) {
	}

	/**
	 * @generated
	 */
	public Object[] getChildren(Object parentElement) {
		if (parentElement instanceof IFile) {
			IFile file = (IFile) parentElement;
			URI fileURI = URI.createPlatformResourceURI(file.getFullPath()
					.toString(), true);
			Resource resource = myEditingDomain.getResourceSet().getResource(
					fileURI, true);
			ArrayList<FsdNavigatorItem> result = new ArrayList<FsdNavigatorItem>();
			ArrayList<View> topViews = new ArrayList<View>(resource
					.getContents().size());
			for (EObject o : resource.getContents()) {
				if (o instanceof View) {
					topViews.add((View) o);
				}
			}
			result.addAll(createNavigatorItems(
					selectViewsByType(topViews, InteractionEditPart.MODEL_ID),
					file, false));
			return result.toArray();
		}

		if (parentElement instanceof FsdNavigatorGroup) {
			FsdNavigatorGroup group = (FsdNavigatorGroup) parentElement;
			return group.getChildren();
		}

		if (parentElement instanceof FsdNavigatorItem) {
			FsdNavigatorItem navigatorItem = (FsdNavigatorItem) parentElement;
			if (navigatorItem.isLeaf() || !isOwnView(navigatorItem.getView())) {
				return EMPTY_ARRAY;
			}
			return getViewChildren(navigatorItem.getView(), parentElement);
		}

		return EMPTY_ARRAY;
	}

	/**
	 * @generated
	 */
	private Object[] getViewChildren(View view, Object parentElement) {
		switch (FsdVisualIDRegistry.getVisualID(view)) {

		case InteractionEditPart.VISUAL_ID: {
			LinkedList<FsdAbstractNavigatorItem> result = new LinkedList<FsdAbstractNavigatorItem>();
			Diagram sv = (Diagram) view;
			FsdNavigatorGroup links = new FsdNavigatorGroup(
					Messages.NavigatorGroupName_Interaction_1000_links,
					"icons/linksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getChildrenByType(Collections.singleton(sv),
					FsdVisualIDRegistry
							.getType(FailureComponentHeadEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(sv),
					FsdVisualIDRegistry
							.getType(ComponentHeadEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(sv),
					FsdVisualIDRegistry.getType(FailureNoteEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(sv),
					FsdVisualIDRegistry.getType(ComponentEndEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(sv),
					FsdVisualIDRegistry
							.getType(PartComponentEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(sv),
					FsdVisualIDRegistry
							.getType(PartComponentFailureEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(sv),
					FsdVisualIDRegistry
							.getType(MitigationNoteEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(sv),
					FsdVisualIDRegistry
							.getType(MessageCommentEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(sv),
					FsdVisualIDRegistry
							.getType(FailureIndicatorEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(sv),
					FsdVisualIDRegistry
							.getType(MitigationIndicatorEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getChildrenByType(Collections.singleton(sv),
					FsdVisualIDRegistry
							.getType(FailureComponentEndEditPart.VISUAL_ID));
			result.addAll(createNavigatorItems(connectedViews, parentElement,
					false));
			connectedViews = getDiagramLinksByType(
					Collections.singleton(sv),
					FsdVisualIDRegistry
							.getType(PartComponentRegFailMessageEditPart.VISUAL_ID));
			links.addChildren(createNavigatorItems(connectedViews, links, false));
			connectedViews = getDiagramLinksByType(
					Collections.singleton(sv),
					FsdVisualIDRegistry
							.getType(PartComponentFailureFailureFailureMessageEditPart.VISUAL_ID));
			links.addChildren(createNavigatorItems(connectedViews, links, false));
			connectedViews = getDiagramLinksByType(
					Collections.singleton(sv),
					FsdVisualIDRegistry
							.getType(PartComponentFailureFailRegmessageEditPart.VISUAL_ID));
			links.addChildren(createNavigatorItems(connectedViews, links, false));
			connectedViews = getDiagramLinksByType(
					Collections.singleton(sv),
					FsdVisualIDRegistry
							.getType(PartComponentRegularregularMessageEditPart.VISUAL_ID));
			links.addChildren(createNavigatorItems(connectedViews, links, false));
			connectedViews = getDiagramLinksByType(Collections.singleton(sv),
					FsdVisualIDRegistry
							.getType(ComponentHeadNormalTailEditPart.VISUAL_ID));
			links.addChildren(createNavigatorItems(connectedViews, links, false));
			connectedViews = getDiagramLinksByType(
					Collections.singleton(sv),
					FsdVisualIDRegistry
							.getType(FailureComponentHeadFailureTailEditPart.VISUAL_ID));
			links.addChildren(createNavigatorItems(connectedViews, links, false));
			if (!links.isEmpty()) {
				result.add(links);
			}
			return result.toArray();
		}

		case PartComponentEditPart.VISUAL_ID: {
			LinkedList<FsdAbstractNavigatorItem> result = new LinkedList<FsdAbstractNavigatorItem>();
			Node sv = (Node) view;
			FsdNavigatorGroup outgoinglinks = new FsdNavigatorGroup(
					Messages.NavigatorGroupName_PartComponent_2003_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			FsdNavigatorGroup incominglinks = new FsdNavigatorGroup(
					Messages.NavigatorGroupName_PartComponent_2003_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(sv),
					FsdVisualIDRegistry
							.getType(PartComponentRegFailMessageEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					FsdVisualIDRegistry
							.getType(PartComponentFailureFailRegmessageEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					FsdVisualIDRegistry
							.getType(PartComponentRegularregularMessageEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(sv),
					FsdVisualIDRegistry
							.getType(PartComponentRegularregularMessageEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			return result.toArray();
		}

		case PartComponentFailureEditPart.VISUAL_ID: {
			LinkedList<FsdAbstractNavigatorItem> result = new LinkedList<FsdAbstractNavigatorItem>();
			Node sv = (Node) view;
			FsdNavigatorGroup incominglinks = new FsdNavigatorGroup(
					Messages.NavigatorGroupName_PartComponentFailure_2005_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			FsdNavigatorGroup outgoinglinks = new FsdNavigatorGroup(
					Messages.NavigatorGroupName_PartComponentFailure_2005_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					FsdVisualIDRegistry
							.getType(PartComponentRegFailMessageEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					FsdVisualIDRegistry
							.getType(PartComponentFailureFailureFailureMessageEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(sv),
					FsdVisualIDRegistry
							.getType(PartComponentFailureFailureFailureMessageEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(sv),
					FsdVisualIDRegistry
							.getType(PartComponentFailureFailRegmessageEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case ComponentEndEditPart.VISUAL_ID: {
			LinkedList<FsdAbstractNavigatorItem> result = new LinkedList<FsdAbstractNavigatorItem>();
			Node sv = (Node) view;
			FsdNavigatorGroup incominglinks = new FsdNavigatorGroup(
					Messages.NavigatorGroupName_ComponentEnd_2006_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getIncomingLinksByType(Collections.singleton(sv),
					FsdVisualIDRegistry
							.getType(ComponentHeadNormalTailEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			return result.toArray();
		}

		case ComponentHeadEditPart.VISUAL_ID: {
			LinkedList<FsdAbstractNavigatorItem> result = new LinkedList<FsdAbstractNavigatorItem>();
			Node sv = (Node) view;
			FsdNavigatorGroup outgoinglinks = new FsdNavigatorGroup(
					Messages.NavigatorGroupName_ComponentHead_2007_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getOutgoingLinksByType(Collections.singleton(sv),
					FsdVisualIDRegistry
							.getType(ComponentHeadNormalTailEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case FailureComponentEndEditPart.VISUAL_ID: {
			LinkedList<FsdAbstractNavigatorItem> result = new LinkedList<FsdAbstractNavigatorItem>();
			Node sv = (Node) view;
			FsdNavigatorGroup incominglinks = new FsdNavigatorGroup(
					Messages.NavigatorGroupName_FailureComponentEnd_2010_incominglinks,
					"icons/incomingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getIncomingLinksByType(
					Collections.singleton(sv),
					FsdVisualIDRegistry
							.getType(FailureComponentHeadFailureTailEditPart.VISUAL_ID));
			incominglinks.addChildren(createNavigatorItems(connectedViews,
					incominglinks, true));
			if (!incominglinks.isEmpty()) {
				result.add(incominglinks);
			}
			return result.toArray();
		}

		case FailureComponentHeadEditPart.VISUAL_ID: {
			LinkedList<FsdAbstractNavigatorItem> result = new LinkedList<FsdAbstractNavigatorItem>();
			Node sv = (Node) view;
			FsdNavigatorGroup outgoinglinks = new FsdNavigatorGroup(
					Messages.NavigatorGroupName_FailureComponentHead_2011_outgoinglinks,
					"icons/outgoingLinksNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getOutgoingLinksByType(
					Collections.singleton(sv),
					FsdVisualIDRegistry
							.getType(FailureComponentHeadFailureTailEditPart.VISUAL_ID));
			outgoinglinks.addChildren(createNavigatorItems(connectedViews,
					outgoinglinks, true));
			if (!outgoinglinks.isEmpty()) {
				result.add(outgoinglinks);
			}
			return result.toArray();
		}

		case PartComponentFailureFailureFailureMessageEditPart.VISUAL_ID: {
			LinkedList<FsdAbstractNavigatorItem> result = new LinkedList<FsdAbstractNavigatorItem>();
			Edge sv = (Edge) view;
			FsdNavigatorGroup target = new FsdNavigatorGroup(
					Messages.NavigatorGroupName_PartComponentFailureFailureFailureMessage_4001_target,
					"icons/linkTargetNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			FsdNavigatorGroup source = new FsdNavigatorGroup(
					Messages.NavigatorGroupName_PartComponentFailureFailureFailureMessage_4001_source,
					"icons/linkSourceNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getLinksTargetByType(Collections.singleton(sv),
					FsdVisualIDRegistry
							.getType(PartComponentFailureEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(sv),
					FsdVisualIDRegistry
							.getType(PartComponentFailureEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!target.isEmpty()) {
				result.add(target);
			}
			if (!source.isEmpty()) {
				result.add(source);
			}
			return result.toArray();
		}

		case FailureComponentHeadFailureTailEditPart.VISUAL_ID: {
			LinkedList<FsdAbstractNavigatorItem> result = new LinkedList<FsdAbstractNavigatorItem>();
			Edge sv = (Edge) view;
			FsdNavigatorGroup target = new FsdNavigatorGroup(
					Messages.NavigatorGroupName_FailureComponentHeadFailureTail_4002_target,
					"icons/linkTargetNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			FsdNavigatorGroup source = new FsdNavigatorGroup(
					Messages.NavigatorGroupName_FailureComponentHeadFailureTail_4002_source,
					"icons/linkSourceNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getLinksTargetByType(Collections.singleton(sv),
					FsdVisualIDRegistry
							.getType(FailureComponentEndEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(sv),
					FsdVisualIDRegistry
							.getType(FailureComponentHeadEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!target.isEmpty()) {
				result.add(target);
			}
			if (!source.isEmpty()) {
				result.add(source);
			}
			return result.toArray();
		}

		case PartComponentFailureFailRegmessageEditPart.VISUAL_ID: {
			LinkedList<FsdAbstractNavigatorItem> result = new LinkedList<FsdAbstractNavigatorItem>();
			Edge sv = (Edge) view;
			FsdNavigatorGroup target = new FsdNavigatorGroup(
					Messages.NavigatorGroupName_PartComponentFailureFailRegmessage_4003_target,
					"icons/linkTargetNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			FsdNavigatorGroup source = new FsdNavigatorGroup(
					Messages.NavigatorGroupName_PartComponentFailureFailRegmessage_4003_source,
					"icons/linkSourceNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getLinksTargetByType(Collections.singleton(sv),
					FsdVisualIDRegistry
							.getType(PartComponentEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(sv),
					FsdVisualIDRegistry
							.getType(PartComponentFailureEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!target.isEmpty()) {
				result.add(target);
			}
			if (!source.isEmpty()) {
				result.add(source);
			}
			return result.toArray();
		}

		case ComponentHeadNormalTailEditPart.VISUAL_ID: {
			LinkedList<FsdAbstractNavigatorItem> result = new LinkedList<FsdAbstractNavigatorItem>();
			Edge sv = (Edge) view;
			FsdNavigatorGroup target = new FsdNavigatorGroup(
					Messages.NavigatorGroupName_ComponentHeadNormalTail_4004_target,
					"icons/linkTargetNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			FsdNavigatorGroup source = new FsdNavigatorGroup(
					Messages.NavigatorGroupName_ComponentHeadNormalTail_4004_source,
					"icons/linkSourceNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getLinksTargetByType(Collections.singleton(sv),
					FsdVisualIDRegistry.getType(ComponentEndEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(sv),
					FsdVisualIDRegistry
							.getType(ComponentHeadEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!target.isEmpty()) {
				result.add(target);
			}
			if (!source.isEmpty()) {
				result.add(source);
			}
			return result.toArray();
		}

		case PartComponentRegFailMessageEditPart.VISUAL_ID: {
			LinkedList<FsdAbstractNavigatorItem> result = new LinkedList<FsdAbstractNavigatorItem>();
			Edge sv = (Edge) view;
			FsdNavigatorGroup target = new FsdNavigatorGroup(
					Messages.NavigatorGroupName_PartComponentRegFailMessage_4005_target,
					"icons/linkTargetNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			FsdNavigatorGroup source = new FsdNavigatorGroup(
					Messages.NavigatorGroupName_PartComponentRegFailMessage_4005_source,
					"icons/linkSourceNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getLinksTargetByType(Collections.singleton(sv),
					FsdVisualIDRegistry
							.getType(PartComponentFailureEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(sv),
					FsdVisualIDRegistry
							.getType(PartComponentEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!target.isEmpty()) {
				result.add(target);
			}
			if (!source.isEmpty()) {
				result.add(source);
			}
			return result.toArray();
		}

		case PartComponentRegularregularMessageEditPart.VISUAL_ID: {
			LinkedList<FsdAbstractNavigatorItem> result = new LinkedList<FsdAbstractNavigatorItem>();
			Edge sv = (Edge) view;
			FsdNavigatorGroup target = new FsdNavigatorGroup(
					Messages.NavigatorGroupName_PartComponentRegularregularMessage_4006_target,
					"icons/linkTargetNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			FsdNavigatorGroup source = new FsdNavigatorGroup(
					Messages.NavigatorGroupName_PartComponentRegularregularMessage_4006_source,
					"icons/linkSourceNavigatorGroup.gif", parentElement); //$NON-NLS-1$
			Collection<View> connectedViews;
			connectedViews = getLinksTargetByType(Collections.singleton(sv),
					FsdVisualIDRegistry
							.getType(PartComponentEditPart.VISUAL_ID));
			target.addChildren(createNavigatorItems(connectedViews, target,
					true));
			connectedViews = getLinksSourceByType(Collections.singleton(sv),
					FsdVisualIDRegistry
							.getType(PartComponentEditPart.VISUAL_ID));
			source.addChildren(createNavigatorItems(connectedViews, source,
					true));
			if (!target.isEmpty()) {
				result.add(target);
			}
			if (!source.isEmpty()) {
				result.add(source);
			}
			return result.toArray();
		}
		}
		return EMPTY_ARRAY;
	}

	/**
	 * @generated
	 */
	private Collection<View> getLinksSourceByType(Collection<Edge> edges,
			String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (Edge nextEdge : edges) {
			View nextEdgeSource = nextEdge.getSource();
			if (type.equals(nextEdgeSource.getType())
					&& isOwnView(nextEdgeSource)) {
				result.add(nextEdgeSource);
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getLinksTargetByType(Collection<Edge> edges,
			String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (Edge nextEdge : edges) {
			View nextEdgeTarget = nextEdge.getTarget();
			if (type.equals(nextEdgeTarget.getType())
					&& isOwnView(nextEdgeTarget)) {
				result.add(nextEdgeTarget);
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getOutgoingLinksByType(
			Collection<? extends View> nodes, String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (View nextNode : nodes) {
			result.addAll(selectViewsByType(nextNode.getSourceEdges(), type));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getIncomingLinksByType(
			Collection<? extends View> nodes, String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (View nextNode : nodes) {
			result.addAll(selectViewsByType(nextNode.getTargetEdges(), type));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getChildrenByType(
			Collection<? extends View> nodes, String type) {
		LinkedList<View> result = new LinkedList<View>();
		for (View nextNode : nodes) {
			result.addAll(selectViewsByType(nextNode.getChildren(), type));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private Collection<View> getDiagramLinksByType(
			Collection<Diagram> diagrams, String type) {
		ArrayList<View> result = new ArrayList<View>();
		for (Diagram nextDiagram : diagrams) {
			result.addAll(selectViewsByType(nextDiagram.getEdges(), type));
		}
		return result;
	}

	// TODO refactor as static method
	/**
	 * @generated
	 */
	private Collection<View> selectViewsByType(Collection<View> views,
			String type) {
		ArrayList<View> result = new ArrayList<View>();
		for (View nextView : views) {
			if (type.equals(nextView.getType()) && isOwnView(nextView)) {
				result.add(nextView);
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private boolean isOwnView(View view) {
		return InteractionEditPart.MODEL_ID.equals(FsdVisualIDRegistry
				.getModelID(view));
	}

	/**
	 * @generated
	 */
	private Collection<FsdNavigatorItem> createNavigatorItems(
			Collection<View> views, Object parent, boolean isLeafs) {
		ArrayList<FsdNavigatorItem> result = new ArrayList<FsdNavigatorItem>(
				views.size());
		for (View nextView : views) {
			result.add(new FsdNavigatorItem(nextView, parent, isLeafs));
		}
		return result;
	}

	/**
	 * @generated
	 */
	public Object getParent(Object element) {
		if (element instanceof FsdAbstractNavigatorItem) {
			FsdAbstractNavigatorItem abstractNavigatorItem = (FsdAbstractNavigatorItem) element;
			return abstractNavigatorItem.getParent();
		}
		return null;
	}

	/**
	 * @generated
	 */
	public boolean hasChildren(Object element) {
		return element instanceof IFile || getChildren(element).length > 0;
	}

}
