package fsd.diagram.navigator;

import org.eclipse.gmf.runtime.common.ui.services.parser.IParser;
import org.eclipse.gmf.runtime.common.ui.services.parser.ParserOptions;
import org.eclipse.gmf.runtime.emf.core.util.EObjectAdapter;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.jface.viewers.ITreePathLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.TreePath;
import org.eclipse.jface.viewers.ViewerLabel;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.navigator.ICommonContentExtensionSite;
import org.eclipse.ui.navigator.ICommonLabelProvider;

import fsd.diagram.edit.parts.ComponentEndEditPart;
import fsd.diagram.edit.parts.ComponentEndEndEditPart;
import fsd.diagram.edit.parts.ComponentHeadEditPart;
import fsd.diagram.edit.parts.ComponentHeadNormalTailEditPart;
import fsd.diagram.edit.parts.ComponentHeadTitleEditPart;
import fsd.diagram.edit.parts.FailureComponentEndEditPart;
import fsd.diagram.edit.parts.FailureComponentEndEndEditPart;
import fsd.diagram.edit.parts.FailureComponentHeadEditPart;
import fsd.diagram.edit.parts.FailureComponentHeadFailureTailEditPart;
import fsd.diagram.edit.parts.FailureComponentHeadTitleEditPart;
import fsd.diagram.edit.parts.FailureIndicatorEditPart;
import fsd.diagram.edit.parts.FailureNoteEditPart;
import fsd.diagram.edit.parts.FailureNoteTextEditPart;
import fsd.diagram.edit.parts.InteractionEditPart;
import fsd.diagram.edit.parts.MessageCommentEditPart;
import fsd.diagram.edit.parts.MessageCommentMessageEditPart;
import fsd.diagram.edit.parts.MitigationIndicatorEditPart;
import fsd.diagram.edit.parts.MitigationNoteEditPart;
import fsd.diagram.edit.parts.MitigationNoteTextEditPart;
import fsd.diagram.edit.parts.PartComponentEditPart;
import fsd.diagram.edit.parts.PartComponentFailureEditPart;
import fsd.diagram.edit.parts.PartComponentFailureFailRegmessageEditPart;
import fsd.diagram.edit.parts.PartComponentFailureFailureFailureMessageEditPart;
import fsd.diagram.edit.parts.PartComponentRegFailMessageEditPart;
import fsd.diagram.edit.parts.PartComponentRegularregularMessageEditPart;
import fsd.diagram.part.FsdDiagramEditorPlugin;
import fsd.diagram.part.FsdVisualIDRegistry;
import fsd.diagram.providers.FsdElementTypes;
import fsd.diagram.providers.FsdParserProvider;

/**
 * @generated
 */
public class FsdNavigatorLabelProvider extends LabelProvider implements
		ICommonLabelProvider, ITreePathLabelProvider {

	/**
	 * @generated
	 */
	static {
		FsdDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put("Navigator?UnknownElement", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
		FsdDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put("Navigator?ImageNotFound", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	public void updateLabel(ViewerLabel label, TreePath elementPath) {
		Object element = elementPath.getLastSegment();
		if (element instanceof FsdNavigatorItem
				&& !isOwnView(((FsdNavigatorItem) element).getView())) {
			return;
		}
		label.setText(getText(element));
		label.setImage(getImage(element));
	}

	/**
	 * @generated
	 */
	public Image getImage(Object element) {
		if (element instanceof FsdNavigatorGroup) {
			FsdNavigatorGroup group = (FsdNavigatorGroup) element;
			return FsdDiagramEditorPlugin.getInstance().getBundledImage(
					group.getIcon());
		}

		if (element instanceof FsdNavigatorItem) {
			FsdNavigatorItem navigatorItem = (FsdNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return super.getImage(element);
			}
			return getImage(navigatorItem.getView());
		}

		return super.getImage(element);
	}

	/**
	 * @generated
	 */
	public Image getImage(View view) {
		switch (FsdVisualIDRegistry.getVisualID(view)) {
		case InteractionEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Diagram?angelfoss/master/chassis?Interaction", FsdElementTypes.Interaction_1000); //$NON-NLS-1$
		case FailureIndicatorEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?angelfoss/master/chassis?FailureIndicator", FsdElementTypes.FailureIndicator_2001); //$NON-NLS-1$
		case FailureNoteEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?angelfoss/master/chassis?FailureNote", FsdElementTypes.FailureNote_2002); //$NON-NLS-1$
		case PartComponentEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?angelfoss/master/chassis?PartComponent", FsdElementTypes.PartComponent_2003); //$NON-NLS-1$
		case MitigationIndicatorEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?angelfoss/master/chassis?MitigationIndicator", FsdElementTypes.MitigationIndicator_2004); //$NON-NLS-1$
		case PartComponentFailureEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?angelfoss/master/chassis?PartComponentFailure", FsdElementTypes.PartComponentFailure_2005); //$NON-NLS-1$
		case ComponentEndEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?angelfoss/master/chassis?ComponentEnd", FsdElementTypes.ComponentEnd_2006); //$NON-NLS-1$
		case ComponentHeadEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?angelfoss/master/chassis?ComponentHead", FsdElementTypes.ComponentHead_2007); //$NON-NLS-1$
		case MessageCommentEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?angelfoss/master/chassis?MessageComment", FsdElementTypes.MessageComment_2008); //$NON-NLS-1$
		case MitigationNoteEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?angelfoss/master/chassis?MitigationNote", FsdElementTypes.MitigationNote_2009); //$NON-NLS-1$
		case FailureComponentEndEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?angelfoss/master/chassis?FailureComponentEnd", FsdElementTypes.FailureComponentEnd_2010); //$NON-NLS-1$
		case FailureComponentHeadEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?angelfoss/master/chassis?FailureComponentHead", FsdElementTypes.FailureComponentHead_2011); //$NON-NLS-1$
		case PartComponentFailureFailureFailureMessageEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?angelfoss/master/chassis?PartComponentFailure?failureFailureMessage", FsdElementTypes.PartComponentFailureFailureFailureMessage_4001); //$NON-NLS-1$
		case FailureComponentHeadFailureTailEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?angelfoss/master/chassis?FailureComponentHead?failureTail", FsdElementTypes.FailureComponentHeadFailureTail_4002); //$NON-NLS-1$
		case PartComponentFailureFailRegmessageEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?angelfoss/master/chassis?PartComponentFailure?failRegmessage", FsdElementTypes.PartComponentFailureFailRegmessage_4003); //$NON-NLS-1$
		case ComponentHeadNormalTailEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?angelfoss/master/chassis?ComponentHead?normalTail", FsdElementTypes.ComponentHeadNormalTail_4004); //$NON-NLS-1$
		case PartComponentRegFailMessageEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?angelfoss/master/chassis?PartComponent?regFailMessage", FsdElementTypes.PartComponentRegFailMessage_4005); //$NON-NLS-1$
		case PartComponentRegularregularMessageEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?angelfoss/master/chassis?PartComponent?regularregularMessage", FsdElementTypes.PartComponentRegularregularMessage_4006); //$NON-NLS-1$
		}
		return getImage("Navigator?UnknownElement", null); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private Image getImage(String key, IElementType elementType) {
		ImageRegistry imageRegistry = FsdDiagramEditorPlugin.getInstance()
				.getImageRegistry();
		Image image = imageRegistry.get(key);
		if (image == null && elementType != null
				&& FsdElementTypes.isKnownElementType(elementType)) {
			image = FsdElementTypes.getImage(elementType);
			imageRegistry.put(key, image);
		}

		if (image == null) {
			image = imageRegistry.get("Navigator?ImageNotFound"); //$NON-NLS-1$
			imageRegistry.put(key, image);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public String getText(Object element) {
		if (element instanceof FsdNavigatorGroup) {
			FsdNavigatorGroup group = (FsdNavigatorGroup) element;
			return group.getGroupName();
		}

		if (element instanceof FsdNavigatorItem) {
			FsdNavigatorItem navigatorItem = (FsdNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return null;
			}
			return getText(navigatorItem.getView());
		}

		return super.getText(element);
	}

	/**
	 * @generated
	 */
	public String getText(View view) {
		if (view.getElement() != null && view.getElement().eIsProxy()) {
			return getUnresolvedDomainElementProxyText(view);
		}
		switch (FsdVisualIDRegistry.getVisualID(view)) {
		case InteractionEditPart.VISUAL_ID:
			return getInteraction_1000Text(view);
		case FailureIndicatorEditPart.VISUAL_ID:
			return getFailureIndicator_2001Text(view);
		case FailureNoteEditPart.VISUAL_ID:
			return getFailureNote_2002Text(view);
		case PartComponentEditPart.VISUAL_ID:
			return getPartComponent_2003Text(view);
		case MitigationIndicatorEditPart.VISUAL_ID:
			return getMitigationIndicator_2004Text(view);
		case PartComponentFailureEditPart.VISUAL_ID:
			return getPartComponentFailure_2005Text(view);
		case ComponentEndEditPart.VISUAL_ID:
			return getComponentEnd_2006Text(view);
		case ComponentHeadEditPart.VISUAL_ID:
			return getComponentHead_2007Text(view);
		case MessageCommentEditPart.VISUAL_ID:
			return getMessageComment_2008Text(view);
		case MitigationNoteEditPart.VISUAL_ID:
			return getMitigationNote_2009Text(view);
		case FailureComponentEndEditPart.VISUAL_ID:
			return getFailureComponentEnd_2010Text(view);
		case FailureComponentHeadEditPart.VISUAL_ID:
			return getFailureComponentHead_2011Text(view);
		case PartComponentFailureFailureFailureMessageEditPart.VISUAL_ID:
			return getPartComponentFailureFailureFailureMessage_4001Text(view);
		case FailureComponentHeadFailureTailEditPart.VISUAL_ID:
			return getFailureComponentHeadFailureTail_4002Text(view);
		case PartComponentFailureFailRegmessageEditPart.VISUAL_ID:
			return getPartComponentFailureFailRegmessage_4003Text(view);
		case ComponentHeadNormalTailEditPart.VISUAL_ID:
			return getComponentHeadNormalTail_4004Text(view);
		case PartComponentRegFailMessageEditPart.VISUAL_ID:
			return getPartComponentRegFailMessage_4005Text(view);
		case PartComponentRegularregularMessageEditPart.VISUAL_ID:
			return getPartComponentRegularregularMessage_4006Text(view);
		}
		return getUnknownElementText(view);
	}

	/**
	 * @generated
	 */
	private String getInteraction_1000Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getFailureIndicator_2001Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getFailureNote_2002Text(View view) {
		IParser parser = FsdParserProvider.getParser(
				FsdElementTypes.FailureNote_2002,
				view.getElement() != null ? view.getElement() : view,
				FsdVisualIDRegistry.getType(FailureNoteTextEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			FsdDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5001); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getPartComponent_2003Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getMitigationIndicator_2004Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getPartComponentFailure_2005Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getComponentEnd_2006Text(View view) {
		IParser parser = FsdParserProvider.getParser(
				FsdElementTypes.ComponentEnd_2006,
				view.getElement() != null ? view.getElement() : view,
				FsdVisualIDRegistry.getType(ComponentEndEndEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			FsdDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5002); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getComponentHead_2007Text(View view) {
		IParser parser = FsdParserProvider.getParser(
				FsdElementTypes.ComponentHead_2007,
				view.getElement() != null ? view.getElement() : view,
				FsdVisualIDRegistry
						.getType(ComponentHeadTitleEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			FsdDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5003); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getMessageComment_2008Text(View view) {
		IParser parser = FsdParserProvider.getParser(
				FsdElementTypes.MessageComment_2008,
				view.getElement() != null ? view.getElement() : view,
				FsdVisualIDRegistry
						.getType(MessageCommentMessageEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			FsdDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5004); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getMitigationNote_2009Text(View view) {
		IParser parser = FsdParserProvider.getParser(
				FsdElementTypes.MitigationNote_2009,
				view.getElement() != null ? view.getElement() : view,
				FsdVisualIDRegistry
						.getType(MitigationNoteTextEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			FsdDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5005); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getFailureComponentEnd_2010Text(View view) {
		IParser parser = FsdParserProvider.getParser(
				FsdElementTypes.FailureComponentEnd_2010,
				view.getElement() != null ? view.getElement() : view,
				FsdVisualIDRegistry
						.getType(FailureComponentEndEndEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			FsdDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5006); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getFailureComponentHead_2011Text(View view) {
		IParser parser = FsdParserProvider.getParser(
				FsdElementTypes.FailureComponentHead_2011,
				view.getElement() != null ? view.getElement() : view,
				FsdVisualIDRegistry
						.getType(FailureComponentHeadTitleEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			FsdDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5007); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getPartComponentFailureFailureFailureMessage_4001Text(
			View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getFailureComponentHeadFailureTail_4002Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getPartComponentFailureFailRegmessage_4003Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getComponentHeadNormalTail_4004Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getPartComponentRegFailMessage_4005Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getPartComponentRegularregularMessage_4006Text(View view) {
		return ""; //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private String getUnknownElementText(View view) {
		return "<UnknownElement Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$  //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	private String getUnresolvedDomainElementProxyText(View view) {
		return "<Unresolved domain element Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$  //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	public void init(ICommonContentExtensionSite aConfig) {
	}

	/**
	 * @generated
	 */
	public void restoreState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void saveState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public String getDescription(Object anElement) {
		return null;
	}

	/**
	 * @generated
	 */
	private boolean isOwnView(View view) {
		return InteractionEditPart.MODEL_ID.equals(FsdVisualIDRegistry
				.getModelID(view));
	}

}
