package fsd.diagram.part;

import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.gmf.tooling.runtime.update.DiagramUpdater;

import fsd.ComponentEnd;
import fsd.ComponentHead;
import fsd.FailureComponentEnd;
import fsd.FailureComponentHead;
import fsd.FailureIndicator;
import fsd.FailureNote;
import fsd.FsdPackage;
import fsd.Interaction;
import fsd.MessageComment;
import fsd.MitigationIndicator;
import fsd.MitigationNote;
import fsd.PartComponent;
import fsd.PartComponentFailure;
import fsd.diagram.edit.parts.ComponentEndEditPart;
import fsd.diagram.edit.parts.ComponentHeadEditPart;
import fsd.diagram.edit.parts.ComponentHeadNormalTailEditPart;
import fsd.diagram.edit.parts.FailureComponentEndEditPart;
import fsd.diagram.edit.parts.FailureComponentHeadEditPart;
import fsd.diagram.edit.parts.FailureComponentHeadFailureTailEditPart;
import fsd.diagram.edit.parts.FailureIndicatorEditPart;
import fsd.diagram.edit.parts.FailureNoteEditPart;
import fsd.diagram.edit.parts.InteractionEditPart;
import fsd.diagram.edit.parts.MessageCommentEditPart;
import fsd.diagram.edit.parts.MitigationIndicatorEditPart;
import fsd.diagram.edit.parts.MitigationNoteEditPart;
import fsd.diagram.edit.parts.PartComponentEditPart;
import fsd.diagram.edit.parts.PartComponentFailureEditPart;
import fsd.diagram.edit.parts.PartComponentFailureFailRegmessageEditPart;
import fsd.diagram.edit.parts.PartComponentFailureFailureFailureMessageEditPart;
import fsd.diagram.edit.parts.PartComponentRegFailMessageEditPart;
import fsd.diagram.edit.parts.PartComponentRegularregularMessageEditPart;
import fsd.diagram.providers.FsdElementTypes;

/**
 * @generated
 */
public class FsdDiagramUpdater {

	/**
	 * @generated
	 */
	public static List<FsdNodeDescriptor> getSemanticChildren(View view) {
		switch (FsdVisualIDRegistry.getVisualID(view)) {
		case InteractionEditPart.VISUAL_ID:
			return getInteraction_1000SemanticChildren(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<FsdNodeDescriptor> getInteraction_1000SemanticChildren(
			View view) {
		if (!view.isSetElement()) {
			return Collections.emptyList();
		}
		Interaction modelElement = (Interaction) view.getElement();
		LinkedList<FsdNodeDescriptor> result = new LinkedList<FsdNodeDescriptor>();
		for (Iterator<?> it = modelElement.getFailurecomponentHeads()
				.iterator(); it.hasNext();) {
			FailureComponentHead childElement = (FailureComponentHead) it
					.next();
			int visualID = FsdVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == FailureComponentHeadEditPart.VISUAL_ID) {
				result.add(new FsdNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator<?> it = modelElement.getComponentHeads().iterator(); it
				.hasNext();) {
			ComponentHead childElement = (ComponentHead) it.next();
			int visualID = FsdVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == ComponentHeadEditPart.VISUAL_ID) {
				result.add(new FsdNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator<?> it = modelElement.getFailurenotes().iterator(); it
				.hasNext();) {
			FailureNote childElement = (FailureNote) it.next();
			int visualID = FsdVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == FailureNoteEditPart.VISUAL_ID) {
				result.add(new FsdNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator<?> it = modelElement.getComponentEnds().iterator(); it
				.hasNext();) {
			ComponentEnd childElement = (ComponentEnd) it.next();
			int visualID = FsdVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == ComponentEndEditPart.VISUAL_ID) {
				result.add(new FsdNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator<?> it = modelElement.getPartComponents().iterator(); it
				.hasNext();) {
			PartComponent childElement = (PartComponent) it.next();
			int visualID = FsdVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == PartComponentEditPart.VISUAL_ID) {
				result.add(new FsdNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator<?> it = modelElement.getPartcomponentfailures()
				.iterator(); it.hasNext();) {
			PartComponentFailure childElement = (PartComponentFailure) it
					.next();
			int visualID = FsdVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == PartComponentFailureEditPart.VISUAL_ID) {
				result.add(new FsdNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator<?> it = modelElement.getMitigationnotes().iterator(); it
				.hasNext();) {
			MitigationNote childElement = (MitigationNote) it.next();
			int visualID = FsdVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == MitigationNoteEditPart.VISUAL_ID) {
				result.add(new FsdNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator<?> it = modelElement.getMessagecomments().iterator(); it
				.hasNext();) {
			MessageComment childElement = (MessageComment) it.next();
			int visualID = FsdVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == MessageCommentEditPart.VISUAL_ID) {
				result.add(new FsdNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator<?> it = modelElement.getFailureindicators().iterator(); it
				.hasNext();) {
			FailureIndicator childElement = (FailureIndicator) it.next();
			int visualID = FsdVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == FailureIndicatorEditPart.VISUAL_ID) {
				result.add(new FsdNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator<?> it = modelElement.getMitigationindicator().iterator(); it
				.hasNext();) {
			MitigationIndicator childElement = (MitigationIndicator) it.next();
			int visualID = FsdVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == MitigationIndicatorEditPart.VISUAL_ID) {
				result.add(new FsdNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator<?> it = modelElement.getFailurecomponentEnds().iterator(); it
				.hasNext();) {
			FailureComponentEnd childElement = (FailureComponentEnd) it.next();
			int visualID = FsdVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == FailureComponentEndEditPart.VISUAL_ID) {
				result.add(new FsdNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List<FsdLinkDescriptor> getContainedLinks(View view) {
		switch (FsdVisualIDRegistry.getVisualID(view)) {
		case InteractionEditPart.VISUAL_ID:
			return getInteraction_1000ContainedLinks(view);
		case FailureComponentHeadEditPart.VISUAL_ID:
			return getFailureComponentHead_2011ContainedLinks(view);
		case ComponentHeadEditPart.VISUAL_ID:
			return getComponentHead_2007ContainedLinks(view);
		case FailureNoteEditPart.VISUAL_ID:
			return getFailureNote_2002ContainedLinks(view);
		case ComponentEndEditPart.VISUAL_ID:
			return getComponentEnd_2006ContainedLinks(view);
		case PartComponentEditPart.VISUAL_ID:
			return getPartComponent_2003ContainedLinks(view);
		case PartComponentFailureEditPart.VISUAL_ID:
			return getPartComponentFailure_2005ContainedLinks(view);
		case MitigationNoteEditPart.VISUAL_ID:
			return getMitigationNote_2009ContainedLinks(view);
		case MessageCommentEditPart.VISUAL_ID:
			return getMessageComment_2008ContainedLinks(view);
		case FailureIndicatorEditPart.VISUAL_ID:
			return getFailureIndicator_2001ContainedLinks(view);
		case MitigationIndicatorEditPart.VISUAL_ID:
			return getMitigationIndicator_2004ContainedLinks(view);
		case FailureComponentEndEditPart.VISUAL_ID:
			return getFailureComponentEnd_2010ContainedLinks(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<FsdLinkDescriptor> getIncomingLinks(View view) {
		switch (FsdVisualIDRegistry.getVisualID(view)) {
		case FailureComponentHeadEditPart.VISUAL_ID:
			return getFailureComponentHead_2011IncomingLinks(view);
		case ComponentHeadEditPart.VISUAL_ID:
			return getComponentHead_2007IncomingLinks(view);
		case FailureNoteEditPart.VISUAL_ID:
			return getFailureNote_2002IncomingLinks(view);
		case ComponentEndEditPart.VISUAL_ID:
			return getComponentEnd_2006IncomingLinks(view);
		case PartComponentEditPart.VISUAL_ID:
			return getPartComponent_2003IncomingLinks(view);
		case PartComponentFailureEditPart.VISUAL_ID:
			return getPartComponentFailure_2005IncomingLinks(view);
		case MitigationNoteEditPart.VISUAL_ID:
			return getMitigationNote_2009IncomingLinks(view);
		case MessageCommentEditPart.VISUAL_ID:
			return getMessageComment_2008IncomingLinks(view);
		case FailureIndicatorEditPart.VISUAL_ID:
			return getFailureIndicator_2001IncomingLinks(view);
		case MitigationIndicatorEditPart.VISUAL_ID:
			return getMitigationIndicator_2004IncomingLinks(view);
		case FailureComponentEndEditPart.VISUAL_ID:
			return getFailureComponentEnd_2010IncomingLinks(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<FsdLinkDescriptor> getOutgoingLinks(View view) {
		switch (FsdVisualIDRegistry.getVisualID(view)) {
		case FailureComponentHeadEditPart.VISUAL_ID:
			return getFailureComponentHead_2011OutgoingLinks(view);
		case ComponentHeadEditPart.VISUAL_ID:
			return getComponentHead_2007OutgoingLinks(view);
		case FailureNoteEditPart.VISUAL_ID:
			return getFailureNote_2002OutgoingLinks(view);
		case ComponentEndEditPart.VISUAL_ID:
			return getComponentEnd_2006OutgoingLinks(view);
		case PartComponentEditPart.VISUAL_ID:
			return getPartComponent_2003OutgoingLinks(view);
		case PartComponentFailureEditPart.VISUAL_ID:
			return getPartComponentFailure_2005OutgoingLinks(view);
		case MitigationNoteEditPart.VISUAL_ID:
			return getMitigationNote_2009OutgoingLinks(view);
		case MessageCommentEditPart.VISUAL_ID:
			return getMessageComment_2008OutgoingLinks(view);
		case FailureIndicatorEditPart.VISUAL_ID:
			return getFailureIndicator_2001OutgoingLinks(view);
		case MitigationIndicatorEditPart.VISUAL_ID:
			return getMitigationIndicator_2004OutgoingLinks(view);
		case FailureComponentEndEditPart.VISUAL_ID:
			return getFailureComponentEnd_2010OutgoingLinks(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<FsdLinkDescriptor> getInteraction_1000ContainedLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<FsdLinkDescriptor> getFailureIndicator_2001ContainedLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<FsdLinkDescriptor> getFailureNote_2002ContainedLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<FsdLinkDescriptor> getPartComponent_2003ContainedLinks(
			View view) {
		PartComponent modelElement = (PartComponent) view.getElement();
		LinkedList<FsdLinkDescriptor> result = new LinkedList<FsdLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_PartComponent_RegFailMessage_4005(modelElement));
		result.addAll(getOutgoingFeatureModelFacetLinks_PartComponent_RegularregularMessage_4006(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<FsdLinkDescriptor> getMitigationIndicator_2004ContainedLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<FsdLinkDescriptor> getPartComponentFailure_2005ContainedLinks(
			View view) {
		PartComponentFailure modelElement = (PartComponentFailure) view
				.getElement();
		LinkedList<FsdLinkDescriptor> result = new LinkedList<FsdLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_PartComponentFailure_FailureFailureMessage_4001(modelElement));
		result.addAll(getOutgoingFeatureModelFacetLinks_PartComponentFailure_FailRegmessage_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<FsdLinkDescriptor> getComponentEnd_2006ContainedLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<FsdLinkDescriptor> getComponentHead_2007ContainedLinks(
			View view) {
		ComponentHead modelElement = (ComponentHead) view.getElement();
		LinkedList<FsdLinkDescriptor> result = new LinkedList<FsdLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_ComponentHead_NormalTail_4004(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<FsdLinkDescriptor> getMessageComment_2008ContainedLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<FsdLinkDescriptor> getMitigationNote_2009ContainedLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<FsdLinkDescriptor> getFailureComponentEnd_2010ContainedLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<FsdLinkDescriptor> getFailureComponentHead_2011ContainedLinks(
			View view) {
		FailureComponentHead modelElement = (FailureComponentHead) view
				.getElement();
		LinkedList<FsdLinkDescriptor> result = new LinkedList<FsdLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_FailureComponentHead_FailureTail_4002(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<FsdLinkDescriptor> getFailureIndicator_2001IncomingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<FsdLinkDescriptor> getFailureNote_2002IncomingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<FsdLinkDescriptor> getPartComponent_2003IncomingLinks(
			View view) {
		PartComponent modelElement = (PartComponent) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<FsdLinkDescriptor> result = new LinkedList<FsdLinkDescriptor>();
		result.addAll(getIncomingFeatureModelFacetLinks_PartComponentFailure_FailRegmessage_4003(
				modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_PartComponent_RegularregularMessage_4006(
				modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<FsdLinkDescriptor> getMitigationIndicator_2004IncomingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<FsdLinkDescriptor> getPartComponentFailure_2005IncomingLinks(
			View view) {
		PartComponentFailure modelElement = (PartComponentFailure) view
				.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<FsdLinkDescriptor> result = new LinkedList<FsdLinkDescriptor>();
		result.addAll(getIncomingFeatureModelFacetLinks_PartComponent_RegFailMessage_4005(
				modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_PartComponentFailure_FailureFailureMessage_4001(
				modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<FsdLinkDescriptor> getComponentEnd_2006IncomingLinks(
			View view) {
		ComponentEnd modelElement = (ComponentEnd) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<FsdLinkDescriptor> result = new LinkedList<FsdLinkDescriptor>();
		result.addAll(getIncomingFeatureModelFacetLinks_ComponentHead_NormalTail_4004(
				modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<FsdLinkDescriptor> getComponentHead_2007IncomingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<FsdLinkDescriptor> getMessageComment_2008IncomingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<FsdLinkDescriptor> getMitigationNote_2009IncomingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<FsdLinkDescriptor> getFailureComponentEnd_2010IncomingLinks(
			View view) {
		FailureComponentEnd modelElement = (FailureComponentEnd) view
				.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer
				.find(view.eResource().getResourceSet().getResources());
		LinkedList<FsdLinkDescriptor> result = new LinkedList<FsdLinkDescriptor>();
		result.addAll(getIncomingFeatureModelFacetLinks_FailureComponentHead_FailureTail_4002(
				modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<FsdLinkDescriptor> getFailureComponentHead_2011IncomingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<FsdLinkDescriptor> getFailureIndicator_2001OutgoingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<FsdLinkDescriptor> getFailureNote_2002OutgoingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<FsdLinkDescriptor> getPartComponent_2003OutgoingLinks(
			View view) {
		PartComponent modelElement = (PartComponent) view.getElement();
		LinkedList<FsdLinkDescriptor> result = new LinkedList<FsdLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_PartComponent_RegFailMessage_4005(modelElement));
		result.addAll(getOutgoingFeatureModelFacetLinks_PartComponent_RegularregularMessage_4006(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<FsdLinkDescriptor> getMitigationIndicator_2004OutgoingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<FsdLinkDescriptor> getPartComponentFailure_2005OutgoingLinks(
			View view) {
		PartComponentFailure modelElement = (PartComponentFailure) view
				.getElement();
		LinkedList<FsdLinkDescriptor> result = new LinkedList<FsdLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_PartComponentFailure_FailureFailureMessage_4001(modelElement));
		result.addAll(getOutgoingFeatureModelFacetLinks_PartComponentFailure_FailRegmessage_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<FsdLinkDescriptor> getComponentEnd_2006OutgoingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<FsdLinkDescriptor> getComponentHead_2007OutgoingLinks(
			View view) {
		ComponentHead modelElement = (ComponentHead) view.getElement();
		LinkedList<FsdLinkDescriptor> result = new LinkedList<FsdLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_ComponentHead_NormalTail_4004(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<FsdLinkDescriptor> getMessageComment_2008OutgoingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<FsdLinkDescriptor> getMitigationNote_2009OutgoingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<FsdLinkDescriptor> getFailureComponentEnd_2010OutgoingLinks(
			View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<FsdLinkDescriptor> getFailureComponentHead_2011OutgoingLinks(
			View view) {
		FailureComponentHead modelElement = (FailureComponentHead) view
				.getElement();
		LinkedList<FsdLinkDescriptor> result = new LinkedList<FsdLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_FailureComponentHead_FailureTail_4002(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<FsdLinkDescriptor> getIncomingFeatureModelFacetLinks_PartComponentFailure_FailureFailureMessage_4001(
			PartComponentFailure target,
			Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<FsdLinkDescriptor> result = new LinkedList<FsdLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences
				.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() == FsdPackage.eINSTANCE
					.getPartComponentFailure_FailureFailureMessage()) {
				result.add(new FsdLinkDescriptor(
						setting.getEObject(),
						target,
						FsdElementTypes.PartComponentFailureFailureFailureMessage_4001,
						PartComponentFailureFailureFailureMessageEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<FsdLinkDescriptor> getIncomingFeatureModelFacetLinks_FailureComponentHead_FailureTail_4002(
			FailureComponentEnd target,
			Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<FsdLinkDescriptor> result = new LinkedList<FsdLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences
				.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() == FsdPackage.eINSTANCE
					.getFailureComponentHead_FailureTail()) {
				result.add(new FsdLinkDescriptor(setting.getEObject(), target,
						FsdElementTypes.FailureComponentHeadFailureTail_4002,
						FailureComponentHeadFailureTailEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<FsdLinkDescriptor> getIncomingFeatureModelFacetLinks_PartComponentFailure_FailRegmessage_4003(
			PartComponent target,
			Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<FsdLinkDescriptor> result = new LinkedList<FsdLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences
				.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() == FsdPackage.eINSTANCE
					.getPartComponentFailure_FailRegmessage()) {
				result.add(new FsdLinkDescriptor(
						setting.getEObject(),
						target,
						FsdElementTypes.PartComponentFailureFailRegmessage_4003,
						PartComponentFailureFailRegmessageEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<FsdLinkDescriptor> getIncomingFeatureModelFacetLinks_ComponentHead_NormalTail_4004(
			ComponentEnd target,
			Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<FsdLinkDescriptor> result = new LinkedList<FsdLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences
				.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() == FsdPackage.eINSTANCE
					.getComponentHead_NormalTail()) {
				result.add(new FsdLinkDescriptor(setting.getEObject(), target,
						FsdElementTypes.ComponentHeadNormalTail_4004,
						ComponentHeadNormalTailEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<FsdLinkDescriptor> getIncomingFeatureModelFacetLinks_PartComponent_RegFailMessage_4005(
			PartComponentFailure target,
			Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<FsdLinkDescriptor> result = new LinkedList<FsdLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences
				.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() == FsdPackage.eINSTANCE
					.getPartComponent_RegFailMessage()) {
				result.add(new FsdLinkDescriptor(setting.getEObject(), target,
						FsdElementTypes.PartComponentRegFailMessage_4005,
						PartComponentRegFailMessageEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<FsdLinkDescriptor> getIncomingFeatureModelFacetLinks_PartComponent_RegularregularMessage_4006(
			PartComponent target,
			Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<FsdLinkDescriptor> result = new LinkedList<FsdLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences
				.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() == FsdPackage.eINSTANCE
					.getPartComponent_RegularregularMessage()) {
				result.add(new FsdLinkDescriptor(
						setting.getEObject(),
						target,
						FsdElementTypes.PartComponentRegularregularMessage_4006,
						PartComponentRegularregularMessageEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<FsdLinkDescriptor> getOutgoingFeatureModelFacetLinks_PartComponentFailure_FailureFailureMessage_4001(
			PartComponentFailure source) {
		LinkedList<FsdLinkDescriptor> result = new LinkedList<FsdLinkDescriptor>();
		for (Iterator<?> destinations = source.getFailureFailureMessage()
				.iterator(); destinations.hasNext();) {
			PartComponentFailure destination = (PartComponentFailure) destinations
					.next();
			result.add(new FsdLinkDescriptor(
					source,
					destination,
					FsdElementTypes.PartComponentFailureFailureFailureMessage_4001,
					PartComponentFailureFailureFailureMessageEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<FsdLinkDescriptor> getOutgoingFeatureModelFacetLinks_FailureComponentHead_FailureTail_4002(
			FailureComponentHead source) {
		LinkedList<FsdLinkDescriptor> result = new LinkedList<FsdLinkDescriptor>();
		for (Iterator<?> destinations = source.getFailureTail().iterator(); destinations
				.hasNext();) {
			FailureComponentEnd destination = (FailureComponentEnd) destinations
					.next();
			result.add(new FsdLinkDescriptor(source, destination,
					FsdElementTypes.FailureComponentHeadFailureTail_4002,
					FailureComponentHeadFailureTailEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<FsdLinkDescriptor> getOutgoingFeatureModelFacetLinks_PartComponentFailure_FailRegmessage_4003(
			PartComponentFailure source) {
		LinkedList<FsdLinkDescriptor> result = new LinkedList<FsdLinkDescriptor>();
		for (Iterator<?> destinations = source.getFailRegmessage().iterator(); destinations
				.hasNext();) {
			PartComponent destination = (PartComponent) destinations.next();
			result.add(new FsdLinkDescriptor(source, destination,
					FsdElementTypes.PartComponentFailureFailRegmessage_4003,
					PartComponentFailureFailRegmessageEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<FsdLinkDescriptor> getOutgoingFeatureModelFacetLinks_ComponentHead_NormalTail_4004(
			ComponentHead source) {
		LinkedList<FsdLinkDescriptor> result = new LinkedList<FsdLinkDescriptor>();
		for (Iterator<?> destinations = source.getNormalTail().iterator(); destinations
				.hasNext();) {
			ComponentEnd destination = (ComponentEnd) destinations.next();
			result.add(new FsdLinkDescriptor(source, destination,
					FsdElementTypes.ComponentHeadNormalTail_4004,
					ComponentHeadNormalTailEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<FsdLinkDescriptor> getOutgoingFeatureModelFacetLinks_PartComponent_RegFailMessage_4005(
			PartComponent source) {
		LinkedList<FsdLinkDescriptor> result = new LinkedList<FsdLinkDescriptor>();
		for (Iterator<?> destinations = source.getRegFailMessage().iterator(); destinations
				.hasNext();) {
			PartComponentFailure destination = (PartComponentFailure) destinations
					.next();
			result.add(new FsdLinkDescriptor(source, destination,
					FsdElementTypes.PartComponentRegFailMessage_4005,
					PartComponentRegFailMessageEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<FsdLinkDescriptor> getOutgoingFeatureModelFacetLinks_PartComponent_RegularregularMessage_4006(
			PartComponent source) {
		LinkedList<FsdLinkDescriptor> result = new LinkedList<FsdLinkDescriptor>();
		for (Iterator<?> destinations = source.getRegularregularMessage()
				.iterator(); destinations.hasNext();) {
			PartComponent destination = (PartComponent) destinations.next();
			result.add(new FsdLinkDescriptor(source, destination,
					FsdElementTypes.PartComponentRegularregularMessage_4006,
					PartComponentRegularregularMessageEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static final DiagramUpdater TYPED_INSTANCE = new DiagramUpdater() {
		/**
		 * @generated
		 */
		@Override
		public List<FsdNodeDescriptor> getSemanticChildren(View view) {
			return FsdDiagramUpdater.getSemanticChildren(view);
		}

		/**
		 * @generated
		 */
		@Override
		public List<FsdLinkDescriptor> getContainedLinks(View view) {
			return FsdDiagramUpdater.getContainedLinks(view);
		}

		/**
		 * @generated
		 */
		@Override
		public List<FsdLinkDescriptor> getIncomingLinks(View view) {
			return FsdDiagramUpdater.getIncomingLinks(view);
		}

		/**
		 * @generated
		 */
		@Override
		public List<FsdLinkDescriptor> getOutgoingLinks(View view) {
			return FsdDiagramUpdater.getOutgoingLinks(view);
		}
	};

}
