package fsd.diagram.part;

import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.gmf.tooling.runtime.structure.DiagramStructure;

import fsd.FsdPackage;
import fsd.Interaction;
import fsd.diagram.edit.parts.ComponentEndEditPart;
import fsd.diagram.edit.parts.ComponentEndEndEditPart;
import fsd.diagram.edit.parts.ComponentHeadEditPart;
import fsd.diagram.edit.parts.ComponentHeadTitleEditPart;
import fsd.diagram.edit.parts.FailureComponentEndEditPart;
import fsd.diagram.edit.parts.FailureComponentEndEndEditPart;
import fsd.diagram.edit.parts.FailureComponentHeadEditPart;
import fsd.diagram.edit.parts.FailureComponentHeadTitleEditPart;
import fsd.diagram.edit.parts.FailureIndicatorEditPart;
import fsd.diagram.edit.parts.FailureNoteEditPart;
import fsd.diagram.edit.parts.FailureNoteTextEditPart;
import fsd.diagram.edit.parts.InteractionEditPart;
import fsd.diagram.edit.parts.MessageCommentEditPart;
import fsd.diagram.edit.parts.MessageCommentMessageEditPart;
import fsd.diagram.edit.parts.MitigationIndicatorEditPart;
import fsd.diagram.edit.parts.MitigationNoteEditPart;
import fsd.diagram.edit.parts.MitigationNoteTextEditPart;
import fsd.diagram.edit.parts.PartComponentEditPart;
import fsd.diagram.edit.parts.PartComponentFailureEditPart;

/**
 * This registry is used to determine which type of visual object should be
 * created for the corresponding Diagram, Node, ChildNode or Link represented
 * by a domain model object.
 * 
 * @generated
 */
public class FsdVisualIDRegistry {

	/**
	 * @generated
	 */
	private static final String DEBUG_KEY = "angelfoss.master.chassis.diagram/debug/visualID"; //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static int getVisualID(View view) {
		if (view instanceof Diagram) {
			if (InteractionEditPart.MODEL_ID.equals(view.getType())) {
				return InteractionEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		return fsd.diagram.part.FsdVisualIDRegistry.getVisualID(view.getType());
	}

	/**
	 * @generated
	 */
	public static String getModelID(View view) {
		View diagram = view.getDiagram();
		while (view != diagram) {
			EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
			if (annotation != null) {
				return (String) annotation.getDetails().get("modelID"); //$NON-NLS-1$
			}
			view = (View) view.eContainer();
		}
		return diagram != null ? diagram.getType() : null;
	}

	/**
	 * @generated
	 */
	public static int getVisualID(String type) {
		try {
			return Integer.parseInt(type);
		} catch (NumberFormatException e) {
			if (Boolean.TRUE.toString().equalsIgnoreCase(
					Platform.getDebugOption(DEBUG_KEY))) {
				FsdDiagramEditorPlugin.getInstance().logError(
						"Unable to parse view type as a visualID number: "
								+ type);
			}
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static String getType(int visualID) {
		return Integer.toString(visualID);
	}

	/**
	 * @generated
	 */
	public static int getDiagramVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (FsdPackage.eINSTANCE.getInteraction().isSuperTypeOf(
				domainElement.eClass())
				&& isDiagram((Interaction) domainElement)) {
			return InteractionEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static int getNodeVisualID(View containerView, EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		String containerModelID = fsd.diagram.part.FsdVisualIDRegistry
				.getModelID(containerView);
		if (!InteractionEditPart.MODEL_ID.equals(containerModelID)) {
			return -1;
		}
		int containerVisualID;
		if (InteractionEditPart.MODEL_ID.equals(containerModelID)) {
			containerVisualID = fsd.diagram.part.FsdVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = InteractionEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		switch (containerVisualID) {
		case InteractionEditPart.VISUAL_ID:
			if (FsdPackage.eINSTANCE.getFailureComponentHead().isSuperTypeOf(
					domainElement.eClass())) {
				return FailureComponentHeadEditPart.VISUAL_ID;
			}
			if (FsdPackage.eINSTANCE.getComponentHead().isSuperTypeOf(
					domainElement.eClass())) {
				return ComponentHeadEditPart.VISUAL_ID;
			}
			if (FsdPackage.eINSTANCE.getFailureNote().isSuperTypeOf(
					domainElement.eClass())) {
				return FailureNoteEditPart.VISUAL_ID;
			}
			if (FsdPackage.eINSTANCE.getComponentEnd().isSuperTypeOf(
					domainElement.eClass())) {
				return ComponentEndEditPart.VISUAL_ID;
			}
			if (FsdPackage.eINSTANCE.getPartComponent().isSuperTypeOf(
					domainElement.eClass())) {
				return PartComponentEditPart.VISUAL_ID;
			}
			if (FsdPackage.eINSTANCE.getPartComponentFailure().isSuperTypeOf(
					domainElement.eClass())) {
				return PartComponentFailureEditPart.VISUAL_ID;
			}
			if (FsdPackage.eINSTANCE.getMitigationNote().isSuperTypeOf(
					domainElement.eClass())) {
				return MitigationNoteEditPart.VISUAL_ID;
			}
			if (FsdPackage.eINSTANCE.getMessageComment().isSuperTypeOf(
					domainElement.eClass())) {
				return MessageCommentEditPart.VISUAL_ID;
			}
			if (FsdPackage.eINSTANCE.getFailureIndicator().isSuperTypeOf(
					domainElement.eClass())) {
				return FailureIndicatorEditPart.VISUAL_ID;
			}
			if (FsdPackage.eINSTANCE.getMitigationIndicator().isSuperTypeOf(
					domainElement.eClass())) {
				return MitigationIndicatorEditPart.VISUAL_ID;
			}
			if (FsdPackage.eINSTANCE.getFailureComponentEnd().isSuperTypeOf(
					domainElement.eClass())) {
				return FailureComponentEndEditPart.VISUAL_ID;
			}
			break;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static boolean canCreateNode(View containerView, int nodeVisualID) {
		String containerModelID = fsd.diagram.part.FsdVisualIDRegistry
				.getModelID(containerView);
		if (!InteractionEditPart.MODEL_ID.equals(containerModelID)) {
			return false;
		}
		int containerVisualID;
		if (InteractionEditPart.MODEL_ID.equals(containerModelID)) {
			containerVisualID = fsd.diagram.part.FsdVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = InteractionEditPart.VISUAL_ID;
			} else {
				return false;
			}
		}
		switch (containerVisualID) {
		case InteractionEditPart.VISUAL_ID:
			if (FailureComponentHeadEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (ComponentHeadEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (FailureNoteEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (ComponentEndEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (PartComponentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (PartComponentFailureEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (MitigationNoteEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (MessageCommentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (FailureIndicatorEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (MitigationIndicatorEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (FailureComponentEndEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case FailureComponentHeadEditPart.VISUAL_ID:
			if (FailureComponentHeadTitleEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case ComponentHeadEditPart.VISUAL_ID:
			if (ComponentHeadTitleEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case FailureNoteEditPart.VISUAL_ID:
			if (FailureNoteTextEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case ComponentEndEditPart.VISUAL_ID:
			if (ComponentEndEndEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case MitigationNoteEditPart.VISUAL_ID:
			if (MitigationNoteTextEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case MessageCommentEditPart.VISUAL_ID:
			if (MessageCommentMessageEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case FailureComponentEndEditPart.VISUAL_ID:
			if (FailureComponentEndEndEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static int getLinkWithClassVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 * 
	 * @generated
	 */
	private static boolean isDiagram(Interaction element) {
		return true;
	}

	/**
	 * @generated
	 */
	public static boolean checkNodeVisualID(View containerView,
			EObject domainElement, int candidate) {
		if (candidate == -1) {
			//unrecognized id is always bad
			return false;
		}
		int basic = getNodeVisualID(containerView, domainElement);
		return basic == candidate;
	}

	/**
	 * @generated
	 */
	public static boolean isCompartmentVisualID(int visualID) {
		return false;
	}

	/**
	 * @generated
	 */
	public static boolean isSemanticLeafVisualID(int visualID) {
		switch (visualID) {
		case InteractionEditPart.VISUAL_ID:
			return false;
		case FailureIndicatorEditPart.VISUAL_ID:
		case FailureNoteEditPart.VISUAL_ID:
		case PartComponentEditPart.VISUAL_ID:
		case MitigationIndicatorEditPart.VISUAL_ID:
		case PartComponentFailureEditPart.VISUAL_ID:
		case ComponentEndEditPart.VISUAL_ID:
		case ComponentHeadEditPart.VISUAL_ID:
		case MessageCommentEditPart.VISUAL_ID:
		case MitigationNoteEditPart.VISUAL_ID:
		case FailureComponentEndEditPart.VISUAL_ID:
		case FailureComponentHeadEditPart.VISUAL_ID:
			return true;
		default:
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static final DiagramStructure TYPED_INSTANCE = new DiagramStructure() {
		/**
		 * @generated
		 */
		@Override
		public int getVisualID(View view) {
			return fsd.diagram.part.FsdVisualIDRegistry.getVisualID(view);
		}

		/**
		 * @generated
		 */
		@Override
		public String getModelID(View view) {
			return fsd.diagram.part.FsdVisualIDRegistry.getModelID(view);
		}

		/**
		 * @generated
		 */
		@Override
		public int getNodeVisualID(View containerView, EObject domainElement) {
			return fsd.diagram.part.FsdVisualIDRegistry.getNodeVisualID(
					containerView, domainElement);
		}

		/**
		 * @generated
		 */
		@Override
		public boolean checkNodeVisualID(View containerView,
				EObject domainElement, int candidate) {
			return fsd.diagram.part.FsdVisualIDRegistry.checkNodeVisualID(
					containerView, domainElement, candidate);
		}

		/**
		 * @generated
		 */
		@Override
		public boolean isCompartmentVisualID(int visualID) {
			return fsd.diagram.part.FsdVisualIDRegistry
					.isCompartmentVisualID(visualID);
		}

		/**
		 * @generated
		 */
		@Override
		public boolean isSemanticLeafVisualID(int visualID) {
			return fsd.diagram.part.FsdVisualIDRegistry
					.isSemanticLeafVisualID(visualID);
		}
	};

}
