package fsd.diagram.providers;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.service.AbstractProvider;
import org.eclipse.gmf.runtime.common.core.service.IOperation;
import org.eclipse.gmf.runtime.common.ui.services.parser.GetParserOperation;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParser;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParserProvider;
import org.eclipse.gmf.runtime.common.ui.services.parser.ParserService;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.emf.ui.services.parser.ParserHintAdapter;
import org.eclipse.gmf.runtime.notation.View;

import fsd.FsdPackage;
import fsd.diagram.edit.parts.ComponentEndEndEditPart;
import fsd.diagram.edit.parts.ComponentHeadTitleEditPart;
import fsd.diagram.edit.parts.FailureComponentEndEndEditPart;
import fsd.diagram.edit.parts.FailureComponentHeadTitleEditPart;
import fsd.diagram.edit.parts.FailureNoteTextEditPart;
import fsd.diagram.edit.parts.MessageCommentMessageEditPart;
import fsd.diagram.edit.parts.MitigationNoteTextEditPart;
import fsd.diagram.parsers.MessageFormatParser;
import fsd.diagram.part.FsdVisualIDRegistry;

/**
 * @generated
 */
public class FsdParserProvider extends AbstractProvider implements
		IParserProvider {

	/**
	 * @generated
	 */
	private IParser failureNoteText_5001Parser;

	/**
	 * @generated
	 */
	private IParser getFailureNoteText_5001Parser() {
		if (failureNoteText_5001Parser == null) {
			EAttribute[] features = new EAttribute[] { FsdPackage.eINSTANCE
					.getFailureNote_Text() };
			MessageFormatParser parser = new MessageFormatParser(features);
			failureNoteText_5001Parser = parser;
		}
		return failureNoteText_5001Parser;
	}

	/**
	 * @generated
	 */
	private IParser componentEndEnd_5002Parser;

	/**
	 * @generated
	 */
	private IParser getComponentEndEnd_5002Parser() {
		if (componentEndEnd_5002Parser == null) {
			EAttribute[] features = new EAttribute[] { FsdPackage.eINSTANCE
					.getComponentEnd_End() };
			MessageFormatParser parser = new MessageFormatParser(features);
			componentEndEnd_5002Parser = parser;
		}
		return componentEndEnd_5002Parser;
	}

	/**
	 * @generated
	 */
	private IParser componentHeadTitle_5003Parser;

	/**
	 * @generated
	 */
	private IParser getComponentHeadTitle_5003Parser() {
		if (componentHeadTitle_5003Parser == null) {
			EAttribute[] features = new EAttribute[] { FsdPackage.eINSTANCE
					.getComponentHead_Title() };
			MessageFormatParser parser = new MessageFormatParser(features);
			componentHeadTitle_5003Parser = parser;
		}
		return componentHeadTitle_5003Parser;
	}

	/**
	 * @generated
	 */
	private IParser messageCommentMessage_5004Parser;

	/**
	 * @generated
	 */
	private IParser getMessageCommentMessage_5004Parser() {
		if (messageCommentMessage_5004Parser == null) {
			EAttribute[] features = new EAttribute[] { FsdPackage.eINSTANCE
					.getMessageComment_Message() };
			MessageFormatParser parser = new MessageFormatParser(features);
			messageCommentMessage_5004Parser = parser;
		}
		return messageCommentMessage_5004Parser;
	}

	/**
	 * @generated
	 */
	private IParser mitigationNoteText_5005Parser;

	/**
	 * @generated
	 */
	private IParser getMitigationNoteText_5005Parser() {
		if (mitigationNoteText_5005Parser == null) {
			EAttribute[] features = new EAttribute[] { FsdPackage.eINSTANCE
					.getMitigationNote_Text() };
			MessageFormatParser parser = new MessageFormatParser(features);
			mitigationNoteText_5005Parser = parser;
		}
		return mitigationNoteText_5005Parser;
	}

	/**
	 * @generated
	 */
	private IParser failureComponentEndEnd_5006Parser;

	/**
	 * @generated
	 */
	private IParser getFailureComponentEndEnd_5006Parser() {
		if (failureComponentEndEnd_5006Parser == null) {
			EAttribute[] features = new EAttribute[] { FsdPackage.eINSTANCE
					.getFailureComponentEnd_End() };
			MessageFormatParser parser = new MessageFormatParser(features);
			failureComponentEndEnd_5006Parser = parser;
		}
		return failureComponentEndEnd_5006Parser;
	}

	/**
	 * @generated
	 */
	private IParser failureComponentHeadTitle_5007Parser;

	/**
	 * @generated
	 */
	private IParser getFailureComponentHeadTitle_5007Parser() {
		if (failureComponentHeadTitle_5007Parser == null) {
			EAttribute[] features = new EAttribute[] { FsdPackage.eINSTANCE
					.getFailureComponentHead_Title() };
			MessageFormatParser parser = new MessageFormatParser(features);
			failureComponentHeadTitle_5007Parser = parser;
		}
		return failureComponentHeadTitle_5007Parser;
	}

	/**
	 * @generated
	 */
	protected IParser getParser(int visualID) {
		switch (visualID) {
		case FailureComponentHeadTitleEditPart.VISUAL_ID:
			return getFailureComponentHeadTitle_5007Parser();
		case ComponentHeadTitleEditPart.VISUAL_ID:
			return getComponentHeadTitle_5003Parser();
		case FailureNoteTextEditPart.VISUAL_ID:
			return getFailureNoteText_5001Parser();
		case ComponentEndEndEditPart.VISUAL_ID:
			return getComponentEndEnd_5002Parser();
		case MitigationNoteTextEditPart.VISUAL_ID:
			return getMitigationNoteText_5005Parser();
		case MessageCommentMessageEditPart.VISUAL_ID:
			return getMessageCommentMessage_5004Parser();
		case FailureComponentEndEndEditPart.VISUAL_ID:
			return getFailureComponentEndEnd_5006Parser();
		}
		return null;
	}

	/**
	 * Utility method that consults ParserService
	 * @generated
	 */
	public static IParser getParser(IElementType type, EObject object,
			String parserHint) {
		return ParserService.getInstance().getParser(
				new HintAdapter(type, object, parserHint));
	}

	/**
	 * @generated
	 */
	public IParser getParser(IAdaptable hint) {
		String vid = (String) hint.getAdapter(String.class);
		if (vid != null) {
			return getParser(FsdVisualIDRegistry.getVisualID(vid));
		}
		View view = (View) hint.getAdapter(View.class);
		if (view != null) {
			return getParser(FsdVisualIDRegistry.getVisualID(view));
		}
		return null;
	}

	/**
	 * @generated
	 */
	public boolean provides(IOperation operation) {
		if (operation instanceof GetParserOperation) {
			IAdaptable hint = ((GetParserOperation) operation).getHint();
			if (FsdElementTypes.getElement(hint) == null) {
				return false;
			}
			return getParser(hint) != null;
		}
		return false;
	}

	/**
	 * @generated
	 */
	private static class HintAdapter extends ParserHintAdapter {

		/**
		 * @generated
		 */
		private final IElementType elementType;

		/**
		 * @generated
		 */
		public HintAdapter(IElementType type, EObject object, String parserHint) {
			super(object, parserHint);
			assert type != null;
			elementType = type;
		}

		/**
		 * @generated
		 */
		public Object getAdapter(Class adapter) {
			if (IElementType.class.equals(adapter)) {
				return elementType;
			}
			return super.getAdapter(adapter);
		}
	}

}
