/**
 */
package fsd.provider;

import fsd.util.FsdAdapterFactory;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class FsdItemProviderAdapterFactory extends FsdAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable {
	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComposedAdapterFactory parentAdapterFactory;

	/**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IChangeNotifier changeNotifier = new ChangeNotifier();

	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Collection<Object> supportedTypes = new ArrayList<Object>();

	/**
	 * This constructs an instance.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FsdItemProviderAdapterFactory() {
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
		supportedTypes.add(IItemPropertySource.class);
	}

	/**
	 * This keeps track of the one adapter used for all {@link fsd.Interaction} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected InteractionItemProvider interactionItemProvider;

	/**
	 * This creates an adapter for a {@link fsd.Interaction}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createInteractionAdapter() {
		if (interactionItemProvider == null) {
			interactionItemProvider = new InteractionItemProvider(this);
		}

		return interactionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fsd.FailureIndicator} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FailureIndicatorItemProvider failureIndicatorItemProvider;

	/**
	 * This creates an adapter for a {@link fsd.FailureIndicator}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createFailureIndicatorAdapter() {
		if (failureIndicatorItemProvider == null) {
			failureIndicatorItemProvider = new FailureIndicatorItemProvider(this);
		}

		return failureIndicatorItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fsd.ComponentHead} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComponentHeadItemProvider componentHeadItemProvider;

	/**
	 * This creates an adapter for a {@link fsd.ComponentHead}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createComponentHeadAdapter() {
		if (componentHeadItemProvider == null) {
			componentHeadItemProvider = new ComponentHeadItemProvider(this);
		}

		return componentHeadItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fsd.FailureComponentEnd} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FailureComponentEndItemProvider failureComponentEndItemProvider;

	/**
	 * This creates an adapter for a {@link fsd.FailureComponentEnd}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createFailureComponentEndAdapter() {
		if (failureComponentEndItemProvider == null) {
			failureComponentEndItemProvider = new FailureComponentEndItemProvider(this);
		}

		return failureComponentEndItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fsd.PartComponent} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PartComponentItemProvider partComponentItemProvider;

	/**
	 * This creates an adapter for a {@link fsd.PartComponent}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createPartComponentAdapter() {
		if (partComponentItemProvider == null) {
			partComponentItemProvider = new PartComponentItemProvider(this);
		}

		return partComponentItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fsd.FailureNote} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FailureNoteItemProvider failureNoteItemProvider;

	/**
	 * This creates an adapter for a {@link fsd.FailureNote}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createFailureNoteAdapter() {
		if (failureNoteItemProvider == null) {
			failureNoteItemProvider = new FailureNoteItemProvider(this);
		}

		return failureNoteItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fsd.MitigationIndicator} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MitigationIndicatorItemProvider mitigationIndicatorItemProvider;

	/**
	 * This creates an adapter for a {@link fsd.MitigationIndicator}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createMitigationIndicatorAdapter() {
		if (mitigationIndicatorItemProvider == null) {
			mitigationIndicatorItemProvider = new MitigationIndicatorItemProvider(this);
		}

		return mitigationIndicatorItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fsd.FailureComponentHead} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FailureComponentHeadItemProvider failureComponentHeadItemProvider;

	/**
	 * This creates an adapter for a {@link fsd.FailureComponentHead}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createFailureComponentHeadAdapter() {
		if (failureComponentHeadItemProvider == null) {
			failureComponentHeadItemProvider = new FailureComponentHeadItemProvider(this);
		}

		return failureComponentHeadItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fsd.PartComponentFailure} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PartComponentFailureItemProvider partComponentFailureItemProvider;

	/**
	 * This creates an adapter for a {@link fsd.PartComponentFailure}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createPartComponentFailureAdapter() {
		if (partComponentFailureItemProvider == null) {
			partComponentFailureItemProvider = new PartComponentFailureItemProvider(this);
		}

		return partComponentFailureItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fsd.MitigationNote} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MitigationNoteItemProvider mitigationNoteItemProvider;

	/**
	 * This creates an adapter for a {@link fsd.MitigationNote}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createMitigationNoteAdapter() {
		if (mitigationNoteItemProvider == null) {
			mitigationNoteItemProvider = new MitigationNoteItemProvider(this);
		}

		return mitigationNoteItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fsd.MessageComment} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MessageCommentItemProvider messageCommentItemProvider;

	/**
	 * This creates an adapter for a {@link fsd.MessageComment}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createMessageCommentAdapter() {
		if (messageCommentItemProvider == null) {
			messageCommentItemProvider = new MessageCommentItemProvider(this);
		}

		return messageCommentItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link fsd.ComponentEnd} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComponentEndItemProvider componentEndItemProvider;

	/**
	 * This creates an adapter for a {@link fsd.ComponentEnd}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createComponentEndAdapter() {
		if (componentEndItemProvider == null) {
			componentEndItemProvider = new ComponentEndItemProvider(this);
		}

		return componentEndItemProvider;
	}

	/**
	 * This returns the root adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComposeableAdapterFactory getRootAdapterFactory() {
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object type) {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter adapt(Notifier notifier, Object type) {
		return super.adapt(notifier, this);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object adapt(Object object, Object type) {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class<?>) || (((Class<?>)type).isInstance(adapter))) {
				return adapter;
			}
		}

		return null;
	}

	/**
	 * This adds a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void addListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void removeListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void fireNotifyChanged(Notification notification) {
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This disposes all of the item providers created by this factory. 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void dispose() {
		if (interactionItemProvider != null) interactionItemProvider.dispose();
		if (failureIndicatorItemProvider != null) failureIndicatorItemProvider.dispose();
		if (componentHeadItemProvider != null) componentHeadItemProvider.dispose();
		if (failureComponentEndItemProvider != null) failureComponentEndItemProvider.dispose();
		if (partComponentItemProvider != null) partComponentItemProvider.dispose();
		if (failureNoteItemProvider != null) failureNoteItemProvider.dispose();
		if (mitigationIndicatorItemProvider != null) mitigationIndicatorItemProvider.dispose();
		if (failureComponentHeadItemProvider != null) failureComponentHeadItemProvider.dispose();
		if (partComponentFailureItemProvider != null) partComponentFailureItemProvider.dispose();
		if (mitigationNoteItemProvider != null) mitigationNoteItemProvider.dispose();
		if (messageCommentItemProvider != null) messageCommentItemProvider.dispose();
		if (componentEndItemProvider != null) componentEndItemProvider.dispose();
	}

}
