/**
 */
package fsd.provider;


import fsd.FsdFactory;
import fsd.FsdPackage;
import fsd.Interaction;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link fsd.Interaction} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class InteractionItemProvider
	extends ItemProviderAdapter
	implements
		IEditingDomainItemProvider,
		IStructuredItemContentProvider,
		ITreeItemContentProvider,
		IItemLabelProvider,
		IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InteractionItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

		}
		return itemPropertyDescriptors;
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(FsdPackage.Literals.INTERACTION__FAILUREINDICATORS);
			childrenFeatures.add(FsdPackage.Literals.INTERACTION__COMPONENT_HEADS);
			childrenFeatures.add(FsdPackage.Literals.INTERACTION__FAILURECOMPONENT_ENDS);
			childrenFeatures.add(FsdPackage.Literals.INTERACTION__PART_COMPONENTS);
			childrenFeatures.add(FsdPackage.Literals.INTERACTION__FAILURENOTES);
			childrenFeatures.add(FsdPackage.Literals.INTERACTION__MITIGATIONINDICATOR);
			childrenFeatures.add(FsdPackage.Literals.INTERACTION__FAILURECOMPONENT_HEADS);
			childrenFeatures.add(FsdPackage.Literals.INTERACTION__PARTCOMPONENTFAILURES);
			childrenFeatures.add(FsdPackage.Literals.INTERACTION__MITIGATIONNOTES);
			childrenFeatures.add(FsdPackage.Literals.INTERACTION__MESSAGECOMMENTS);
			childrenFeatures.add(FsdPackage.Literals.INTERACTION__COMPONENT_ENDS);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns Interaction.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/Interaction"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		return getString("_UI_Interaction_type");
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(Interaction.class)) {
			case FsdPackage.INTERACTION__FAILUREINDICATORS:
			case FsdPackage.INTERACTION__COMPONENT_HEADS:
			case FsdPackage.INTERACTION__FAILURECOMPONENT_ENDS:
			case FsdPackage.INTERACTION__PART_COMPONENTS:
			case FsdPackage.INTERACTION__FAILURENOTES:
			case FsdPackage.INTERACTION__MITIGATIONINDICATOR:
			case FsdPackage.INTERACTION__FAILURECOMPONENT_HEADS:
			case FsdPackage.INTERACTION__PARTCOMPONENTFAILURES:
			case FsdPackage.INTERACTION__MITIGATIONNOTES:
			case FsdPackage.INTERACTION__MESSAGECOMMENTS:
			case FsdPackage.INTERACTION__COMPONENT_ENDS:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(FsdPackage.Literals.INTERACTION__FAILUREINDICATORS,
				 FsdFactory.eINSTANCE.createFailureIndicator()));

		newChildDescriptors.add
			(createChildParameter
				(FsdPackage.Literals.INTERACTION__COMPONENT_HEADS,
				 FsdFactory.eINSTANCE.createComponentHead()));

		newChildDescriptors.add
			(createChildParameter
				(FsdPackage.Literals.INTERACTION__FAILURECOMPONENT_ENDS,
				 FsdFactory.eINSTANCE.createFailureComponentEnd()));

		newChildDescriptors.add
			(createChildParameter
				(FsdPackage.Literals.INTERACTION__PART_COMPONENTS,
				 FsdFactory.eINSTANCE.createPartComponent()));

		newChildDescriptors.add
			(createChildParameter
				(FsdPackage.Literals.INTERACTION__FAILURENOTES,
				 FsdFactory.eINSTANCE.createFailureNote()));

		newChildDescriptors.add
			(createChildParameter
				(FsdPackage.Literals.INTERACTION__MITIGATIONINDICATOR,
				 FsdFactory.eINSTANCE.createMitigationIndicator()));

		newChildDescriptors.add
			(createChildParameter
				(FsdPackage.Literals.INTERACTION__FAILURECOMPONENT_HEADS,
				 FsdFactory.eINSTANCE.createFailureComponentHead()));

		newChildDescriptors.add
			(createChildParameter
				(FsdPackage.Literals.INTERACTION__PARTCOMPONENTFAILURES,
				 FsdFactory.eINSTANCE.createPartComponentFailure()));

		newChildDescriptors.add
			(createChildParameter
				(FsdPackage.Literals.INTERACTION__MITIGATIONNOTES,
				 FsdFactory.eINSTANCE.createMitigationNote()));

		newChildDescriptors.add
			(createChildParameter
				(FsdPackage.Literals.INTERACTION__MESSAGECOMMENTS,
				 FsdFactory.eINSTANCE.createMessageComment()));

		newChildDescriptors.add
			(createChildParameter
				(FsdPackage.Literals.INTERACTION__COMPONENT_ENDS,
				 FsdFactory.eINSTANCE.createComponentEnd()));
	}

	/**
	 * Return the resource locator for this item provider's resources.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ResourceLocator getResourceLocator() {
		return FsdEditPlugin.INSTANCE;
	}

}
