/**
 */
package fsd;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see fsd.FsdFactory
 * @model kind="package"
 * @generated
 */
public interface FsdPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "fsd";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "angelfoss/master/chassis";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "fsd";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	FsdPackage eINSTANCE = fsd.impl.FsdPackageImpl.init();

	/**
	 * The meta object id for the '{@link fsd.impl.InteractionImpl <em>Interaction</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fsd.impl.InteractionImpl
	 * @see fsd.impl.FsdPackageImpl#getInteraction()
	 * @generated
	 */
	int INTERACTION = 0;

	/**
	 * The feature id for the '<em><b>Failureindicators</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERACTION__FAILUREINDICATORS = 0;

	/**
	 * The feature id for the '<em><b>Component Heads</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERACTION__COMPONENT_HEADS = 1;

	/**
	 * The feature id for the '<em><b>Failurecomponent Ends</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERACTION__FAILURECOMPONENT_ENDS = 2;

	/**
	 * The feature id for the '<em><b>Part Components</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERACTION__PART_COMPONENTS = 3;

	/**
	 * The feature id for the '<em><b>Failurenotes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERACTION__FAILURENOTES = 4;

	/**
	 * The feature id for the '<em><b>Mitigationindicator</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERACTION__MITIGATIONINDICATOR = 5;

	/**
	 * The feature id for the '<em><b>Failurecomponent Heads</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERACTION__FAILURECOMPONENT_HEADS = 6;

	/**
	 * The feature id for the '<em><b>Partcomponentfailures</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERACTION__PARTCOMPONENTFAILURES = 7;

	/**
	 * The feature id for the '<em><b>Mitigationnotes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERACTION__MITIGATIONNOTES = 8;

	/**
	 * The feature id for the '<em><b>Messagecomments</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERACTION__MESSAGECOMMENTS = 9;

	/**
	 * The feature id for the '<em><b>Component Ends</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERACTION__COMPONENT_ENDS = 10;

	/**
	 * The number of structural features of the '<em>Interaction</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERACTION_FEATURE_COUNT = 11;

	/**
	 * The number of operations of the '<em>Interaction</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERACTION_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link fsd.impl.FailureIndicatorImpl <em>Failure Indicator</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fsd.impl.FailureIndicatorImpl
	 * @see fsd.impl.FsdPackageImpl#getFailureIndicator()
	 * @generated
	 */
	int FAILURE_INDICATOR = 1;

	/**
	 * The number of structural features of the '<em>Failure Indicator</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FAILURE_INDICATOR_FEATURE_COUNT = 0;

	/**
	 * The number of operations of the '<em>Failure Indicator</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FAILURE_INDICATOR_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link fsd.impl.ComponentHeadImpl <em>Component Head</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fsd.impl.ComponentHeadImpl
	 * @see fsd.impl.FsdPackageImpl#getComponentHead()
	 * @generated
	 */
	int COMPONENT_HEAD = 2;

	/**
	 * The feature id for the '<em><b>Title</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_HEAD__TITLE = 0;

	/**
	 * The feature id for the '<em><b>Normal Tail</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_HEAD__NORMAL_TAIL = 1;

	/**
	 * The number of structural features of the '<em>Component Head</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_HEAD_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Component Head</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_HEAD_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link fsd.impl.FailureComponentEndImpl <em>Failure Component End</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fsd.impl.FailureComponentEndImpl
	 * @see fsd.impl.FsdPackageImpl#getFailureComponentEnd()
	 * @generated
	 */
	int FAILURE_COMPONENT_END = 3;

	/**
	 * The feature id for the '<em><b>End</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FAILURE_COMPONENT_END__END = 0;

	/**
	 * The number of structural features of the '<em>Failure Component End</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FAILURE_COMPONENT_END_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Failure Component End</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FAILURE_COMPONENT_END_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link fsd.impl.ComponentEndImpl <em>Component End</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fsd.impl.ComponentEndImpl
	 * @see fsd.impl.FsdPackageImpl#getComponentEnd()
	 * @generated
	 */
	int COMPONENT_END = 11;

	/**
	 * The meta object id for the '{@link fsd.impl.PartComponentImpl <em>Part Component</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fsd.impl.PartComponentImpl
	 * @see fsd.impl.FsdPackageImpl#getPartComponent()
	 * @generated
	 */
	int PART_COMPONENT = 4;

	/**
	 * The feature id for the '<em><b>Regularregular Message</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PART_COMPONENT__REGULARREGULAR_MESSAGE = 0;

	/**
	 * The feature id for the '<em><b>Reg Fail Message</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PART_COMPONENT__REG_FAIL_MESSAGE = 1;

	/**
	 * The number of structural features of the '<em>Part Component</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PART_COMPONENT_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Part Component</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PART_COMPONENT_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link fsd.impl.FailureNoteImpl <em>Failure Note</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fsd.impl.FailureNoteImpl
	 * @see fsd.impl.FsdPackageImpl#getFailureNote()
	 * @generated
	 */
	int FAILURE_NOTE = 5;

	/**
	 * The feature id for the '<em><b>Text</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FAILURE_NOTE__TEXT = 0;

	/**
	 * The number of structural features of the '<em>Failure Note</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FAILURE_NOTE_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Failure Note</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FAILURE_NOTE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link fsd.impl.MitigationIndicatorImpl <em>Mitigation Indicator</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fsd.impl.MitigationIndicatorImpl
	 * @see fsd.impl.FsdPackageImpl#getMitigationIndicator()
	 * @generated
	 */
	int MITIGATION_INDICATOR = 6;

	/**
	 * The number of structural features of the '<em>Mitigation Indicator</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MITIGATION_INDICATOR_FEATURE_COUNT = 0;

	/**
	 * The number of operations of the '<em>Mitigation Indicator</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MITIGATION_INDICATOR_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link fsd.impl.FailureComponentHeadImpl <em>Failure Component Head</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fsd.impl.FailureComponentHeadImpl
	 * @see fsd.impl.FsdPackageImpl#getFailureComponentHead()
	 * @generated
	 */
	int FAILURE_COMPONENT_HEAD = 7;

	/**
	 * The feature id for the '<em><b>Title</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FAILURE_COMPONENT_HEAD__TITLE = 0;

	/**
	 * The feature id for the '<em><b>Failure Tail</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FAILURE_COMPONENT_HEAD__FAILURE_TAIL = 1;

	/**
	 * The number of structural features of the '<em>Failure Component Head</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FAILURE_COMPONENT_HEAD_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Failure Component Head</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FAILURE_COMPONENT_HEAD_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link fsd.impl.PartComponentFailureImpl <em>Part Component Failure</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fsd.impl.PartComponentFailureImpl
	 * @see fsd.impl.FsdPackageImpl#getPartComponentFailure()
	 * @generated
	 */
	int PART_COMPONENT_FAILURE = 8;

	/**
	 * The feature id for the '<em><b>Failure Failure Message</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PART_COMPONENT_FAILURE__FAILURE_FAILURE_MESSAGE = 0;

	/**
	 * The feature id for the '<em><b>Fail Regmessage</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PART_COMPONENT_FAILURE__FAIL_REGMESSAGE = 1;

	/**
	 * The number of structural features of the '<em>Part Component Failure</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PART_COMPONENT_FAILURE_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Part Component Failure</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PART_COMPONENT_FAILURE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link fsd.impl.MitigationNoteImpl <em>Mitigation Note</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fsd.impl.MitigationNoteImpl
	 * @see fsd.impl.FsdPackageImpl#getMitigationNote()
	 * @generated
	 */
	int MITIGATION_NOTE = 9;

	/**
	 * The feature id for the '<em><b>Text</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MITIGATION_NOTE__TEXT = 0;

	/**
	 * The number of structural features of the '<em>Mitigation Note</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MITIGATION_NOTE_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Mitigation Note</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MITIGATION_NOTE_OPERATION_COUNT = 0;


	/**
	 * The meta object id for the '{@link fsd.impl.MessageCommentImpl <em>Message Comment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fsd.impl.MessageCommentImpl
	 * @see fsd.impl.FsdPackageImpl#getMessageComment()
	 * @generated
	 */
	int MESSAGE_COMMENT = 10;

	/**
	 * The feature id for the '<em><b>Message</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MESSAGE_COMMENT__MESSAGE = 0;

	/**
	 * The number of structural features of the '<em>Message Comment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MESSAGE_COMMENT_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Message Comment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MESSAGE_COMMENT_OPERATION_COUNT = 0;

	/**
	 * The feature id for the '<em><b>End</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_END__END = 0;

	/**
	 * The number of structural features of the '<em>Component End</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_END_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Component End</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_END_OPERATION_COUNT = 0;


	/**
	 * Returns the meta object for class '{@link fsd.Interaction <em>Interaction</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Interaction</em>'.
	 * @see fsd.Interaction
	 * @generated
	 */
	EClass getInteraction();

	/**
	 * Returns the meta object for the containment reference list '{@link fsd.Interaction#getFailureindicators <em>Failureindicators</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Failureindicators</em>'.
	 * @see fsd.Interaction#getFailureindicators()
	 * @see #getInteraction()
	 * @generated
	 */
	EReference getInteraction_Failureindicators();

	/**
	 * Returns the meta object for the containment reference list '{@link fsd.Interaction#getComponentHeads <em>Component Heads</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Component Heads</em>'.
	 * @see fsd.Interaction#getComponentHeads()
	 * @see #getInteraction()
	 * @generated
	 */
	EReference getInteraction_ComponentHeads();

	/**
	 * Returns the meta object for the containment reference list '{@link fsd.Interaction#getFailurecomponentEnds <em>Failurecomponent Ends</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Failurecomponent Ends</em>'.
	 * @see fsd.Interaction#getFailurecomponentEnds()
	 * @see #getInteraction()
	 * @generated
	 */
	EReference getInteraction_FailurecomponentEnds();

	/**
	 * Returns the meta object for the containment reference list '{@link fsd.Interaction#getComponentEnds <em>Component Ends</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Component Ends</em>'.
	 * @see fsd.Interaction#getComponentEnds()
	 * @see #getInteraction()
	 * @generated
	 */
	EReference getInteraction_ComponentEnds();

	/**
	 * Returns the meta object for the containment reference list '{@link fsd.Interaction#getPartComponents <em>Part Components</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Part Components</em>'.
	 * @see fsd.Interaction#getPartComponents()
	 * @see #getInteraction()
	 * @generated
	 */
	EReference getInteraction_PartComponents();

	/**
	 * Returns the meta object for the containment reference list '{@link fsd.Interaction#getFailurenotes <em>Failurenotes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Failurenotes</em>'.
	 * @see fsd.Interaction#getFailurenotes()
	 * @see #getInteraction()
	 * @generated
	 */
	EReference getInteraction_Failurenotes();

	/**
	 * Returns the meta object for the containment reference list '{@link fsd.Interaction#getMitigationindicator <em>Mitigationindicator</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Mitigationindicator</em>'.
	 * @see fsd.Interaction#getMitigationindicator()
	 * @see #getInteraction()
	 * @generated
	 */
	EReference getInteraction_Mitigationindicator();

	/**
	 * Returns the meta object for the containment reference list '{@link fsd.Interaction#getFailurecomponentHeads <em>Failurecomponent Heads</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Failurecomponent Heads</em>'.
	 * @see fsd.Interaction#getFailurecomponentHeads()
	 * @see #getInteraction()
	 * @generated
	 */
	EReference getInteraction_FailurecomponentHeads();

	/**
	 * Returns the meta object for the containment reference list '{@link fsd.Interaction#getPartcomponentfailures <em>Partcomponentfailures</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Partcomponentfailures</em>'.
	 * @see fsd.Interaction#getPartcomponentfailures()
	 * @see #getInteraction()
	 * @generated
	 */
	EReference getInteraction_Partcomponentfailures();

	/**
	 * Returns the meta object for the containment reference list '{@link fsd.Interaction#getMitigationnotes <em>Mitigationnotes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Mitigationnotes</em>'.
	 * @see fsd.Interaction#getMitigationnotes()
	 * @see #getInteraction()
	 * @generated
	 */
	EReference getInteraction_Mitigationnotes();

	/**
	 * Returns the meta object for the containment reference list '{@link fsd.Interaction#getMessagecomments <em>Messagecomments</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Messagecomments</em>'.
	 * @see fsd.Interaction#getMessagecomments()
	 * @see #getInteraction()
	 * @generated
	 */
	EReference getInteraction_Messagecomments();

	/**
	 * Returns the meta object for class '{@link fsd.FailureIndicator <em>Failure Indicator</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Failure Indicator</em>'.
	 * @see fsd.FailureIndicator
	 * @generated
	 */
	EClass getFailureIndicator();

	/**
	 * Returns the meta object for class '{@link fsd.ComponentHead <em>Component Head</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Component Head</em>'.
	 * @see fsd.ComponentHead
	 * @generated
	 */
	EClass getComponentHead();

	/**
	 * Returns the meta object for the attribute '{@link fsd.ComponentHead#getTitle <em>Title</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Title</em>'.
	 * @see fsd.ComponentHead#getTitle()
	 * @see #getComponentHead()
	 * @generated
	 */
	EAttribute getComponentHead_Title();

	/**
	 * Returns the meta object for the reference list '{@link fsd.ComponentHead#getNormalTail <em>Normal Tail</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Normal Tail</em>'.
	 * @see fsd.ComponentHead#getNormalTail()
	 * @see #getComponentHead()
	 * @generated
	 */
	EReference getComponentHead_NormalTail();

	/**
	 * Returns the meta object for class '{@link fsd.FailureComponentEnd <em>Failure Component End</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Failure Component End</em>'.
	 * @see fsd.FailureComponentEnd
	 * @generated
	 */
	EClass getFailureComponentEnd();

	/**
	 * Returns the meta object for the attribute '{@link fsd.FailureComponentEnd#getEnd <em>End</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>End</em>'.
	 * @see fsd.FailureComponentEnd#getEnd()
	 * @see #getFailureComponentEnd()
	 * @generated
	 */
	EAttribute getFailureComponentEnd_End();

	/**
	 * Returns the meta object for class '{@link fsd.ComponentEnd <em>Component End</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Component End</em>'.
	 * @see fsd.ComponentEnd
	 * @generated
	 */
	EClass getComponentEnd();

	/**
	 * Returns the meta object for the attribute '{@link fsd.ComponentEnd#getEnd <em>End</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>End</em>'.
	 * @see fsd.ComponentEnd#getEnd()
	 * @see #getComponentEnd()
	 * @generated
	 */
	EAttribute getComponentEnd_End();

	/**
	 * Returns the meta object for class '{@link fsd.PartComponent <em>Part Component</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Part Component</em>'.
	 * @see fsd.PartComponent
	 * @generated
	 */
	EClass getPartComponent();

	/**
	 * Returns the meta object for the reference list '{@link fsd.PartComponent#getRegularregularMessage <em>Regularregular Message</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Regularregular Message</em>'.
	 * @see fsd.PartComponent#getRegularregularMessage()
	 * @see #getPartComponent()
	 * @generated
	 */
	EReference getPartComponent_RegularregularMessage();

	/**
	 * Returns the meta object for the reference list '{@link fsd.PartComponent#getRegFailMessage <em>Reg Fail Message</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Reg Fail Message</em>'.
	 * @see fsd.PartComponent#getRegFailMessage()
	 * @see #getPartComponent()
	 * @generated
	 */
	EReference getPartComponent_RegFailMessage();

	/**
	 * Returns the meta object for class '{@link fsd.FailureNote <em>Failure Note</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Failure Note</em>'.
	 * @see fsd.FailureNote
	 * @generated
	 */
	EClass getFailureNote();

	/**
	 * Returns the meta object for the attribute '{@link fsd.FailureNote#getText <em>Text</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Text</em>'.
	 * @see fsd.FailureNote#getText()
	 * @see #getFailureNote()
	 * @generated
	 */
	EAttribute getFailureNote_Text();

	/**
	 * Returns the meta object for class '{@link fsd.MitigationIndicator <em>Mitigation Indicator</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Mitigation Indicator</em>'.
	 * @see fsd.MitigationIndicator
	 * @generated
	 */
	EClass getMitigationIndicator();

	/**
	 * Returns the meta object for class '{@link fsd.FailureComponentHead <em>Failure Component Head</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Failure Component Head</em>'.
	 * @see fsd.FailureComponentHead
	 * @generated
	 */
	EClass getFailureComponentHead();

	/**
	 * Returns the meta object for the attribute '{@link fsd.FailureComponentHead#getTitle <em>Title</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Title</em>'.
	 * @see fsd.FailureComponentHead#getTitle()
	 * @see #getFailureComponentHead()
	 * @generated
	 */
	EAttribute getFailureComponentHead_Title();

	/**
	 * Returns the meta object for the reference list '{@link fsd.FailureComponentHead#getFailureTail <em>Failure Tail</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Failure Tail</em>'.
	 * @see fsd.FailureComponentHead#getFailureTail()
	 * @see #getFailureComponentHead()
	 * @generated
	 */
	EReference getFailureComponentHead_FailureTail();

	/**
	 * Returns the meta object for class '{@link fsd.PartComponentFailure <em>Part Component Failure</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Part Component Failure</em>'.
	 * @see fsd.PartComponentFailure
	 * @generated
	 */
	EClass getPartComponentFailure();

	/**
	 * Returns the meta object for the reference list '{@link fsd.PartComponentFailure#getFailureFailureMessage <em>Failure Failure Message</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Failure Failure Message</em>'.
	 * @see fsd.PartComponentFailure#getFailureFailureMessage()
	 * @see #getPartComponentFailure()
	 * @generated
	 */
	EReference getPartComponentFailure_FailureFailureMessage();

	/**
	 * Returns the meta object for the reference list '{@link fsd.PartComponentFailure#getFailRegmessage <em>Fail Regmessage</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Fail Regmessage</em>'.
	 * @see fsd.PartComponentFailure#getFailRegmessage()
	 * @see #getPartComponentFailure()
	 * @generated
	 */
	EReference getPartComponentFailure_FailRegmessage();

	/**
	 * Returns the meta object for class '{@link fsd.MitigationNote <em>Mitigation Note</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Mitigation Note</em>'.
	 * @see fsd.MitigationNote
	 * @generated
	 */
	EClass getMitigationNote();

	/**
	 * Returns the meta object for the attribute '{@link fsd.MitigationNote#getText <em>Text</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Text</em>'.
	 * @see fsd.MitigationNote#getText()
	 * @see #getMitigationNote()
	 * @generated
	 */
	EAttribute getMitigationNote_Text();

	/**
	 * Returns the meta object for class '{@link fsd.MessageComment <em>Message Comment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Message Comment</em>'.
	 * @see fsd.MessageComment
	 * @generated
	 */
	EClass getMessageComment();

	/**
	 * Returns the meta object for the attribute '{@link fsd.MessageComment#getMessage <em>Message</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Message</em>'.
	 * @see fsd.MessageComment#getMessage()
	 * @see #getMessageComment()
	 * @generated
	 */
	EAttribute getMessageComment_Message();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	FsdFactory getFsdFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link fsd.impl.InteractionImpl <em>Interaction</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fsd.impl.InteractionImpl
		 * @see fsd.impl.FsdPackageImpl#getInteraction()
		 * @generated
		 */
		EClass INTERACTION = eINSTANCE.getInteraction();

		/**
		 * The meta object literal for the '<em><b>Failureindicators</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERACTION__FAILUREINDICATORS = eINSTANCE.getInteraction_Failureindicators();

		/**
		 * The meta object literal for the '<em><b>Component Heads</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERACTION__COMPONENT_HEADS = eINSTANCE.getInteraction_ComponentHeads();

		/**
		 * The meta object literal for the '<em><b>Failurecomponent Ends</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERACTION__FAILURECOMPONENT_ENDS = eINSTANCE.getInteraction_FailurecomponentEnds();

		/**
		 * The meta object literal for the '<em><b>Component Ends</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERACTION__COMPONENT_ENDS = eINSTANCE.getInteraction_ComponentEnds();

		/**
		 * The meta object literal for the '<em><b>Part Components</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERACTION__PART_COMPONENTS = eINSTANCE.getInteraction_PartComponents();

		/**
		 * The meta object literal for the '<em><b>Failurenotes</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERACTION__FAILURENOTES = eINSTANCE.getInteraction_Failurenotes();

		/**
		 * The meta object literal for the '<em><b>Mitigationindicator</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERACTION__MITIGATIONINDICATOR = eINSTANCE.getInteraction_Mitigationindicator();

		/**
		 * The meta object literal for the '<em><b>Failurecomponent Heads</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERACTION__FAILURECOMPONENT_HEADS = eINSTANCE.getInteraction_FailurecomponentHeads();

		/**
		 * The meta object literal for the '<em><b>Partcomponentfailures</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERACTION__PARTCOMPONENTFAILURES = eINSTANCE.getInteraction_Partcomponentfailures();

		/**
		 * The meta object literal for the '<em><b>Mitigationnotes</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERACTION__MITIGATIONNOTES = eINSTANCE.getInteraction_Mitigationnotes();

		/**
		 * The meta object literal for the '<em><b>Messagecomments</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERACTION__MESSAGECOMMENTS = eINSTANCE.getInteraction_Messagecomments();

		/**
		 * The meta object literal for the '{@link fsd.impl.FailureIndicatorImpl <em>Failure Indicator</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fsd.impl.FailureIndicatorImpl
		 * @see fsd.impl.FsdPackageImpl#getFailureIndicator()
		 * @generated
		 */
		EClass FAILURE_INDICATOR = eINSTANCE.getFailureIndicator();

		/**
		 * The meta object literal for the '{@link fsd.impl.ComponentHeadImpl <em>Component Head</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fsd.impl.ComponentHeadImpl
		 * @see fsd.impl.FsdPackageImpl#getComponentHead()
		 * @generated
		 */
		EClass COMPONENT_HEAD = eINSTANCE.getComponentHead();

		/**
		 * The meta object literal for the '<em><b>Title</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute COMPONENT_HEAD__TITLE = eINSTANCE.getComponentHead_Title();

		/**
		 * The meta object literal for the '<em><b>Normal Tail</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COMPONENT_HEAD__NORMAL_TAIL = eINSTANCE.getComponentHead_NormalTail();

		/**
		 * The meta object literal for the '{@link fsd.impl.FailureComponentEndImpl <em>Failure Component End</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fsd.impl.FailureComponentEndImpl
		 * @see fsd.impl.FsdPackageImpl#getFailureComponentEnd()
		 * @generated
		 */
		EClass FAILURE_COMPONENT_END = eINSTANCE.getFailureComponentEnd();

		/**
		 * The meta object literal for the '<em><b>End</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FAILURE_COMPONENT_END__END = eINSTANCE.getFailureComponentEnd_End();

		/**
		 * The meta object literal for the '{@link fsd.impl.ComponentEndImpl <em>Component End</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fsd.impl.ComponentEndImpl
		 * @see fsd.impl.FsdPackageImpl#getComponentEnd()
		 * @generated
		 */
		EClass COMPONENT_END = eINSTANCE.getComponentEnd();

		/**
		 * The meta object literal for the '<em><b>End</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute COMPONENT_END__END = eINSTANCE.getComponentEnd_End();

		/**
		 * The meta object literal for the '{@link fsd.impl.PartComponentImpl <em>Part Component</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fsd.impl.PartComponentImpl
		 * @see fsd.impl.FsdPackageImpl#getPartComponent()
		 * @generated
		 */
		EClass PART_COMPONENT = eINSTANCE.getPartComponent();

		/**
		 * The meta object literal for the '<em><b>Regularregular Message</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PART_COMPONENT__REGULARREGULAR_MESSAGE = eINSTANCE.getPartComponent_RegularregularMessage();

		/**
		 * The meta object literal for the '<em><b>Reg Fail Message</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PART_COMPONENT__REG_FAIL_MESSAGE = eINSTANCE.getPartComponent_RegFailMessage();

		/**
		 * The meta object literal for the '{@link fsd.impl.FailureNoteImpl <em>Failure Note</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fsd.impl.FailureNoteImpl
		 * @see fsd.impl.FsdPackageImpl#getFailureNote()
		 * @generated
		 */
		EClass FAILURE_NOTE = eINSTANCE.getFailureNote();

		/**
		 * The meta object literal for the '<em><b>Text</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FAILURE_NOTE__TEXT = eINSTANCE.getFailureNote_Text();

		/**
		 * The meta object literal for the '{@link fsd.impl.MitigationIndicatorImpl <em>Mitigation Indicator</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fsd.impl.MitigationIndicatorImpl
		 * @see fsd.impl.FsdPackageImpl#getMitigationIndicator()
		 * @generated
		 */
		EClass MITIGATION_INDICATOR = eINSTANCE.getMitigationIndicator();

		/**
		 * The meta object literal for the '{@link fsd.impl.FailureComponentHeadImpl <em>Failure Component Head</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fsd.impl.FailureComponentHeadImpl
		 * @see fsd.impl.FsdPackageImpl#getFailureComponentHead()
		 * @generated
		 */
		EClass FAILURE_COMPONENT_HEAD = eINSTANCE.getFailureComponentHead();

		/**
		 * The meta object literal for the '<em><b>Title</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FAILURE_COMPONENT_HEAD__TITLE = eINSTANCE.getFailureComponentHead_Title();

		/**
		 * The meta object literal for the '<em><b>Failure Tail</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference FAILURE_COMPONENT_HEAD__FAILURE_TAIL = eINSTANCE.getFailureComponentHead_FailureTail();

		/**
		 * The meta object literal for the '{@link fsd.impl.PartComponentFailureImpl <em>Part Component Failure</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fsd.impl.PartComponentFailureImpl
		 * @see fsd.impl.FsdPackageImpl#getPartComponentFailure()
		 * @generated
		 */
		EClass PART_COMPONENT_FAILURE = eINSTANCE.getPartComponentFailure();

		/**
		 * The meta object literal for the '<em><b>Failure Failure Message</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PART_COMPONENT_FAILURE__FAILURE_FAILURE_MESSAGE = eINSTANCE.getPartComponentFailure_FailureFailureMessage();

		/**
		 * The meta object literal for the '<em><b>Fail Regmessage</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PART_COMPONENT_FAILURE__FAIL_REGMESSAGE = eINSTANCE.getPartComponentFailure_FailRegmessage();

		/**
		 * The meta object literal for the '{@link fsd.impl.MitigationNoteImpl <em>Mitigation Note</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fsd.impl.MitigationNoteImpl
		 * @see fsd.impl.FsdPackageImpl#getMitigationNote()
		 * @generated
		 */
		EClass MITIGATION_NOTE = eINSTANCE.getMitigationNote();

		/**
		 * The meta object literal for the '<em><b>Text</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MITIGATION_NOTE__TEXT = eINSTANCE.getMitigationNote_Text();

		/**
		 * The meta object literal for the '{@link fsd.impl.MessageCommentImpl <em>Message Comment</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fsd.impl.MessageCommentImpl
		 * @see fsd.impl.FsdPackageImpl#getMessageComment()
		 * @generated
		 */
		EClass MESSAGE_COMMENT = eINSTANCE.getMessageComment();

		/**
		 * The meta object literal for the '<em><b>Message</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MESSAGE_COMMENT__MESSAGE = eINSTANCE.getMessageComment_Message();

	}

} //FsdPackage
