/**
 */
package fsd.util;

import fsd.*;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see fsd.FsdPackage
 * @generated
 */
public class FsdAdapterFactory extends AdapterFactoryImpl {
	/**
	 * The cached model package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static FsdPackage modelPackage;

	/**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FsdAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = FsdPackage.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc -->
	 * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
	 * <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject)object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

	/**
	 * The switch that delegates to the <code>createXXX</code> methods.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FsdSwitch<Adapter> modelSwitch =
		new FsdSwitch<Adapter>() {
			@Override
			public Adapter caseInteraction(Interaction object) {
				return createInteractionAdapter();
			}
			@Override
			public Adapter caseFailureIndicator(FailureIndicator object) {
				return createFailureIndicatorAdapter();
			}
			@Override
			public Adapter caseComponentHead(ComponentHead object) {
				return createComponentHeadAdapter();
			}
			@Override
			public Adapter caseFailureComponentEnd(FailureComponentEnd object) {
				return createFailureComponentEndAdapter();
			}
			@Override
			public Adapter casePartComponent(PartComponent object) {
				return createPartComponentAdapter();
			}
			@Override
			public Adapter caseFailureNote(FailureNote object) {
				return createFailureNoteAdapter();
			}
			@Override
			public Adapter caseMitigationIndicator(MitigationIndicator object) {
				return createMitigationIndicatorAdapter();
			}
			@Override
			public Adapter caseFailureComponentHead(FailureComponentHead object) {
				return createFailureComponentHeadAdapter();
			}
			@Override
			public Adapter casePartComponentFailure(PartComponentFailure object) {
				return createPartComponentFailureAdapter();
			}
			@Override
			public Adapter caseMitigationNote(MitigationNote object) {
				return createMitigationNoteAdapter();
			}
			@Override
			public Adapter caseMessageComment(MessageComment object) {
				return createMessageCommentAdapter();
			}
			@Override
			public Adapter caseComponentEnd(ComponentEnd object) {
				return createComponentEndAdapter();
			}
			@Override
			public Adapter defaultCase(EObject object) {
				return createEObjectAdapter();
			}
		};

	/**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	@Override
	public Adapter createAdapter(Notifier target) {
		return modelSwitch.doSwitch((EObject)target);
	}


	/**
	 * Creates a new adapter for an object of class '{@link fsd.Interaction <em>Interaction</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see fsd.Interaction
	 * @generated
	 */
	public Adapter createInteractionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link fsd.FailureIndicator <em>Failure Indicator</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see fsd.FailureIndicator
	 * @generated
	 */
	public Adapter createFailureIndicatorAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link fsd.ComponentHead <em>Component Head</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see fsd.ComponentHead
	 * @generated
	 */
	public Adapter createComponentHeadAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link fsd.FailureComponentEnd <em>Failure Component End</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see fsd.FailureComponentEnd
	 * @generated
	 */
	public Adapter createFailureComponentEndAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link fsd.ComponentEnd <em>Component End</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see fsd.ComponentEnd
	 * @generated
	 */
	public Adapter createComponentEndAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link fsd.PartComponent <em>Part Component</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see fsd.PartComponent
	 * @generated
	 */
	public Adapter createPartComponentAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link fsd.FailureNote <em>Failure Note</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see fsd.FailureNote
	 * @generated
	 */
	public Adapter createFailureNoteAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link fsd.MitigationIndicator <em>Mitigation Indicator</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see fsd.MitigationIndicator
	 * @generated
	 */
	public Adapter createMitigationIndicatorAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link fsd.FailureComponentHead <em>Failure Component Head</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see fsd.FailureComponentHead
	 * @generated
	 */
	public Adapter createFailureComponentHeadAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link fsd.PartComponentFailure <em>Part Component Failure</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see fsd.PartComponentFailure
	 * @generated
	 */
	public Adapter createPartComponentFailureAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link fsd.MitigationNote <em>Mitigation Note</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see fsd.MitigationNote
	 * @generated
	 */
	public Adapter createMitigationNoteAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link fsd.MessageComment <em>Message Comment</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see fsd.MessageComment
	 * @generated
	 */
	public Adapter createMessageCommentAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter() {
		return null;
	}

} //FsdAdapterFactory
